
// @(#)AddEmployee.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package control;

import gui.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class AddEmployee {

    EmployeeGui employeeGui;
    HandleEmployee handleEmployee;
    
    //constructor
    public AddEmployee(EmployeeGui p, HandleEmployee h){
	employeeGui = p;
	handleEmployee = h;
    }
    
    //sets the EmployeeGui window 
    public void addAction(){
	String[] list;
	employeeGui.addAction();
	addOkListener();
    }//addAction


    //removes first old listeners and then adds new one
    void addOkListener(){
    removeListeners();
    employeeGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			okAdd();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	});
	
	employeeGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			okAdd();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkListener
    
    void okAdd(){
	String[] list;
	list = employeeGui.getInfo();
	boolean temp = checkList(list);
	if((list[6].equals("Nurse")) || (list[6].equals("Doctor"))){
	    if(list[1].length() == 11){
		if(temp == true){
		    boolean add = false;
		    add = MainHandler.employeeRegister.addEmployee(list);
		    if(add == true){
			employeeGui.
			    setDefaultWindow("A new employee is born");
			handleEmployee.addEmployee = null;
			handleEmployee.action++;
		    }else{
			employeeGui.setInfoLabel
			    ("Employee with birth number '"+
			     list[1]+ "' exsists.");
		    }//else
		}else{
		    employeeGui.setInfoLabel
			("Fill in all fields before "+
				"you press the 'Ok' button");
		}//else
	    }else{
		employeeGui.setInfoLabel
		    ("Birth number must be eleven digits!");
	    }//else
	}else{
	    employeeGui.setInfoLabel
		("Type must be either 'Doctor' or 'nurse'");
	}//else
    }  //okAdd
    
    //remove Listeners that is on the ok button in EmployeeGui window
    void removeListeners(){
	MouseListener[] mls = (MouseListener[])
	    (employeeGui.okButton.getListeners(MouseListener.class));
	       
	for(int i = 0; i < mls.length;i++){
	    if(mls.length > 0){
		employeeGui.okButton.removeMouseListener(mls[i]);
	    }//if
	}//for
	
	KeyListener[] kls = (KeyListener[])
	    (employeeGui.okButton.getListeners(KeyListener.class));
	
	for(int i = 0; i < kls.length;i++){
	    if(mls.length > 0){
		employeeGui.okButton.removeKeyListener(kls[0]);
	    }//if
	}//for
    }//removeListeners
    
    //check that all the fields are used
    boolean checkList(String[] l){
	boolean temp = false;
	String s;
	int t = 0;
	for(int i = 0; i < 6; i++){
	    s = l[i];
	    if(s.length() > 0){
		t++;
	    } else{
		t--;
	    }
	}//for
	if(t == 6){
	    temp = true;
	}else{
	    temp = false;
	}
	return temp;
    }//checkList
}//class AddEmployee
