// @(#)AddPatient.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package control;

import gui.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class AddPatient {

    PatientGui patientGui;
    HandlePatient handlePatient;
    
    //constructor
    public AddPatient(PatientGui p, HandlePatient h){
	patientGui = p;
	handlePatient = h;
    }
    
    //sets the PatientGui window 
    public void addAction(){
	String[] list;
	patientGui.addAction();
	addOkListener();
    }//addAction

    //removes first old listeners and then adds new one
    void addOkListener(){
    removeListeners();
    
    patientGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			addPatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	});
	
	patientGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			addPatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkListener
    
    void addPatient(){
	String[] list;
	list = patientGui.getInfo();
	if(list[1].length() != 11){
	    patientGui.setInfoLabel("Birth number must be eleven digits!");
	}else{
	    boolean temp = checkList(list);
	    if(temp == true){
		boolean add = false;
		add = MainHandler.patientRegister.addPatient(list);
		if(add == true){
		    patientGui.setDefaultWindow("A new patient is born");
		    removeListeners();
		    handlePatient.addPatient = null;
		    handlePatient.action++;
		    handlePatient.addOkListeners();
		}else{
		    patientGui.setInfoLabel("Patient with birth number '"+
					    list[1]+ "' exsists.");
		}//else
	    }else{
		patientGui.setInfoLabel("Fill in all fields before "+
		     "you press the 'Ok' button");
	    }//else
	}//else
    }//addAction
    
    //remove Listeners that is on the ok button in PatientGui window
    void removeListeners(){
	MouseListener[] mls = (MouseListener[])
	    (patientGui.okButton.getListeners(MouseListener.class));
	       
	for(int i = 0; i < mls.length;i++){
	    if(mls.length > 0){
		patientGui.okButton.removeMouseListener(mls[i]);
	    }//if
	}//for
	
	KeyListener[] kls = (KeyListener[])
	    (patientGui.okButton.getListeners(KeyListener.class));
	
	for(int i = 0; i < kls.length;i++){
	    if(mls.length > 0){
		patientGui.okButton.removeKeyListener(kls[0]);
	    }//if
	}//for
    }//removeListeners
    
    boolean checkList(String[] l){
	boolean temp = false;
	String s;
	int t = 0;
	for(int i = 0; i < 5; i++){
	    s = l[i];
	    if(s.length() > 0){
		t++;
	    } else{
		t--;
	    }
	}//for
	if(t == 5){
	    temp = true;
	}else{
	    temp = false;
	}
	return temp;
    }//checkList
}//class AddPatient
