// @(#)AddResources.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package control;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import gui.*;
import model.*;


public class AddResources implements KeyListener, MouseListener{

    SearchWindowGui searchWindowGui;
    HandleResource handleResource;
    ResourcesGui resourcesGui;
    
    String wardChoice;
    String roomChoice;
    String bedChoice;
    String choice;
    String[] parameterString = new String[10];
    String[] fieldArray;
    boolean createCheck;
    
    //constructor
    public AddResources(HandleResource h, SearchWindowGui s){
	handleResource = h;
	searchWindowGui = s;
	resourcesGui = h.resources;
    }//constructor
    
    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    
    //handles the main add functions
    public void handleAddFunction(String s){
	choice = s;
	searchWindowGui.setDefaultWindow("");
	searchWindowGui.okCancelButton();
	okCancelAction();
	if(choice.equals("Ward")){
	    searchWindowGui.setInfoLabel("Press ok button to finish");
	}
	if((choice.equals("Room")) != (choice.equals("Bed"))){
	    searchWindowGui.setWardLabel("Choose ward");
	    getWardList();
	}//if
    }//handleAddFunction
    
    
    //get list of wards.
    public void getWardList(){
	String[] list;
	list = MainHandler.wardRegister.getWardList();
	int length = list.length;
	if(length > 0){
	    searchWindowGui.putWard(list);
	    addWardListener();
	}//if
	else{
	    searchWindowGui.setDefaultWindow("There exist no wards!");
	}
    }//getWardList

    //gets list of rooms
    public void getRoomList(){
	String[] list;
	list = MainHandler.wardRegister.getRoomList(wardChoice);
	int length = list.length;
	if(length > 0){
	    searchWindowGui.putRoom(list);
	    addRoomListener();
	}
	else{
	    searchWindowGui.setDefaultWindow("There exist no rooms!");
	}
    }//getRoomList

    //adds listener to wardCombo
    public void addWardListener(){
	searchWindowGui.wardCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			wardChoice = (String)cb.getSelectedItem();
			resourcesGui.wardString = wardChoice;
			if(choice.equals("Room")){
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}//if room
			if(choice.equals("Bed")){
			    searchWindowGui.setRoomLabel("Choose room");
			    searchWindowGui.removeFromBedWard();
			    getRoomList();
			}//if bed
		    }
		}//if
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });

	searchWindowGui.wardCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	searchWindowGui.wardCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			wardChoice = (String)cb.getSelectedItem();
			resourcesGui.wardString = wardChoice;
			if(choice.equals("Room")){
			    searchWindowGui.setInfoLabel
			    ("Press ok button to finish");
			}//if room
			if(choice.equals("Bed")){
			    searchWindowGui.setRoomLabel("Choose room");
			    searchWindowGui.removeFromBedWard();
			    getRoomList();
			}//if bed
		    }
		}
	    });
    
    }//addWardListener

    //adds listener to roomCombo
    public void addRoomListener(){
	searchWindowGui.roomCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			roomChoice = (String)cb.getSelectedItem();
			resourcesGui.wardString = wardChoice;
			if(choice.equals("Bed")){
			    searchWindowGui.removeFromBedRoom();
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
 	    });

	searchWindowGui.roomCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	searchWindowGui.roomCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			roomChoice = (String)cb.getSelectedItem();
			resourcesGui.wardString = wardChoice;
			if(choice.equals("Bed")){
			    searchWindowGui.removeFromBedRoom();
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
		    }
		}
	    });
    }//addRoomListener

    //adds action to cancel and ok button    
    public void okCancelAction(){
	searchWindowGui.cancelChooseButton.addActionListener
	    (new ActionListener(){
		    public void actionPerformed(ActionEvent e) {
			searchWindowGui.disposeSearchWindowGui();
			handleResource.setWindowCount();
			handleResource.addResources = null;
		    } // actionPerformed
		});//addActionListener cancelChooseButton
		
	searchWindowGui.cancelChooseButton.addKeyListener
	    (new KeyListener(){
		    public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
			    searchWindowGui.disposeSearchWindowGui();
			    handleResource.setWindowCount();
			    handleResource.addResources = null;
			}//if
		    }//keyPressed
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
		});
	
	// sets the action on ok button
	searchWindowGui.okChooseButton.addActionListener
	    (new ActionListener(){
		    public void actionPerformed(ActionEvent e) {
			if(handleResource.function.equals("Add")){
			    okAddFunction();
			}//if
		    } // actionPerformed
		});//addActionListener cancelChooseButton
	
	searchWindowGui.okChooseButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			if(handleResource.function.equals("Add")){
			    okAddFunction();
			}//if
		    }//if
		}//keyPressed
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });//okChhoseButton.addKeyListener
    }//okCancelAction
    
    // add action when ok button is pressed.
    public void okAddFunction(){
	if(searchWindowGui.defaultString.equals("Ward")){
	    searchWindowGui.disposeSearchWindowGui();
	    handleResource.action++;
	    parameterString[0] = handleResource.functionChoice;
  	    parameterString[1] = wardChoice;
	    resourcesGui.addWardInfo(parameterString);
	    resourcesGui.setTypeInfo();
  	    wardChoice = null;
	    handleResource.setWindowCount();
	    resourcesGui.createAddButton();
	    setAddListener();
	}//if
	if(searchWindowGui.defaultString.equals("Room")){
	    if(wardChoice != null){
		handleResource.action++;
		searchWindowGui.disposeSearchWindowGui();
		parameterString[0] = handleResource.functionChoice;
  		parameterString[1] = wardChoice;
		resourcesGui.addRoomInfo(parameterString);
		resourcesGui.setTypeInfo();
  		roomChoice = null;
  		wardChoice = null;
		resourcesGui.createAddButton();
		handleResource.setWindowCount();
		setAddListener();
	    }//if
	    else{
		searchWindowGui.setInfoLabel("Choose from all active "+
					      "dropdown boxes!");
	    }//else
	}//if
	if(searchWindowGui.defaultString.equals("Bed")){
	    if(roomChoice != null && wardChoice != null){
		String[] list = MainHandler.wardRegister.
		    displayRoom(wardChoice, roomChoice);
		handleResource.action++;
		searchWindowGui.disposeSearchWindowGui();
		parameterString[0] = handleResource.functionChoice;
		parameterString[1] = wardChoice;
		parameterString[2] = roomChoice;
		parameterString[3] = bedChoice;
		parameterString[4] = list[2];
		resourcesGui.addBedInfo(parameterString);
		resourcesGui.setTypeInfo();
		wardChoice = null;
		roomChoice = null;
		bedChoice = null;
		handleResource.setWindowCount();
		handleResource.resources.createAddButton();
		setAddListener();
	    }
	    else{
		searchWindowGui.setInfoLabel("Choose from all active "+
					     "dropdown boxes!");
	    }//else
	}//if
    }//okAddFunction
    
    //add listener to add button on window ResourcesGui
    public void setAddListener(){
	resourcesGui.addButton.addKeyListener
	    (new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER)
		    okAction();    
		}
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
		});
	
	resourcesGui.addButton.addMouseListener
	    (new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    okAction();
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//setAddListener
    
    public void okAction(){
	boolean temp;
	int check;
	if(handleResource.functionChoice == null){
	    resourcesGui.setInfoLabel("No action has been performed");
	}else{
	    fieldArray = resourcesGui.setStringArray();
	    temp = checkInput();
	    if(!temp){
		resourcesGui.setInfoLabel("Please fill in all fields "+
					  "before you press 'Add'!");
		clearStringArray();
	    }//
	    if(handleResource.function.equals("Add") && temp){
		check = makeNewResource();
		if(check > 0){
		    if(createCheck == true){
			resourcesGui.setInfoLabel(handleResource.function+
			     " has been performed");
			handleResource.addResources = null;
			resourcesGui.setWardLabel("Ward:");
			resourcesGui.setDefaultResourceWindow
			    ("Resource has been added!");
			if(resourcesGui.addButton != null){
			    resourcesGui.bottomButtonsPanel.
				remove(resourcesGui.addButton);
			}//if
		    } else{
			resourcesGui.setInfoLabel
			    ("Resource number exist."+
			     "Please choose another one!");
			clearStringArray();
		    }//else
		}//if
	    }//if
	}//else
    }//okAction
    
    //adds the apporperiate (s[0]) resources to the right register 
    public int makeNewResource(){
	createCheck = false;
	String type = fieldArray[3];
	int check = 0;
	
	if((type.equals("Waiting")) || (type.equals("Recovery")) || 
	   (type.equals("Operation"))){
	    if(fieldArray[0].equals("Ward")){
		createCheck = MainHandler.wardRegister.
		    createWard(fieldArray);
		check = 1;
	    }
	    if(fieldArray[0].equals("Room")){
		createCheck = MainHandler.wardRegister.
		    createRoom(fieldArray);
		check = 1;
	    }
	    if(fieldArray[0].equals("Bed")){
		if(type.equals(MainHandler.wardRegister.
			       getType(fieldArray[5], fieldArray[6]))){
		createCheck = MainHandler.wardRegister.
		    createBed(fieldArray);
		check = 1;
		}else{
		    resourcesGui.setInfoLabel(choice+
					      " type must be of type '"+
				 MainHandler.wardRegister.
				 getType(fieldArray[5],fieldArray[6])+
				 "' since 'Room " + fieldArray[6]+
				"' is of that type!");
		}
	    }
	}else{
	    resourcesGui.setInfoLabel(choice+
			 " type must be 'Waiting', 'Recovery' or "+
			"'Operation'. Please choose "+
			"another one!");
	}
	return check;
    }//makeNewResource
    
        //clears the StringArray
    public void clearStringArray(){
	for(int i = 1; i < 4;i++)
	  fieldArray[i] = "";
    }//clearStringArray

    //return false if not all fields have been written
    //figure out what to do with available
    public boolean checkInput(){
	boolean temp = false;
	String s;
	int t = 0;
	for(int i = 1; i < 4; i++){
	    s = fieldArray[i];
	    if(s.length() > 0){
		t++;
	    } else{
		t--;
	    }
	}//for
	if(t == 3){
	    temp = true;
	}else{
	    temp = false;
	}
	    return temp;
    }//checkInput
}//class AddResources



