// @(#)HandleEmployee.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package control;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

import gui.*;
import model.*;

public class HandleEmployee implements KeyListener, MouseListener{
    
    public HandleEmployee handleEmployee;
    public EmployeeGui employeeGui;
    
    //attribute that makes it posible to conduct action once
    // at the time
    public int action = 1;
    
    public AddEmployee addEmployee;
    ModifyEmployee modifyEmployee;

    //constructor
    public HandleEmployee(){
	handleEmployee = this;
    }//HandleEmployee
        
    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    
    //make the employee window
    public void makeWindow(){
	employeeGui = new EmployeeGui();
	employeeGui.createEmployeeGui();
	addExitWindowListener();
	addOkListeners();
	addResetListeners();
	addMainButtonListener();
	windowDestroy();
    }//makeWindow
    
    //when the window is destroyd whitout using the exitWindow button
    void windowDestroy(){
	employeeGui.employeeFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    employeeGui.disposeEmployeeGui();
		    if(modifyEmployee != null){
			modifyEmployee.employeeSearch.
			    disposeEmployeeSearch();
		    }
		}//windowClosing
	    }); //addWindodlistener
    }//windowDestroy
    
    public void addResetListeners(){
	employeeGui.resetWindowButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			if(action != 1){
			    action = 1;
			}
			employeeGui.setDefaultWindow("");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.resetWindowButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			if(action != 1){
			    action = 1;
			}
			employeeGui.setDefaultWindow("");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addResetListeners
    
        //adds listeners to exitWindow button in window EmployeeGui
    public void addExitWindowListener(){
	employeeGui.exitWindowButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			employeeGui.disposeEmployeeGui();
			if(modifyEmployee != null){
			    modifyEmployee.employeeSearch.
				disposeEmployeeSearch();
			}
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.exitWindowButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			employeeGui.disposeEmployeeGui();
			if(modifyEmployee != null){
			    modifyEmployee.employeeSearch.
				disposeEmployeeSearch();
			}
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addExitWindowListeer
    
    //adds listeners to ok button in window EmployeeGui
    public void addOkListeners(){
	employeeGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			employeeGui.setInfoLabel("No action to perform!");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			employeeGui.setInfoLabel("No action to perform!");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkListener
    
    //adds listener to main buttons
    public void addMainButtonListener(){
	employeeGui.addButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER ){
			addEmployee();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.addButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			addEmployee();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	employeeGui.displayButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			displayEmployee();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.displayButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			displayEmployee();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	employeeGui.deleteButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			deleteEmployee();
		    }
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.deleteButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			deleteEmployee();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	employeeGui.changeButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			changeEmployee();
		    }
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.changeButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			changeEmployee();
		    }
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	}//addMainButtonListener
	
    void addEmployee(){
	if(action > 0){
	    employeeGui.setDefaultWindow("");
	    action--;
	    addEmployee = new AddEmployee(employeeGui, handleEmployee);
	    addEmployee.addAction();
	}else{
	    employeeGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//addEmployee
	
    void displayEmployee(){
	if(action > 0){
	    employeeGui.setDefaultWindow("");
	    action--;
	    modifyEmployee = new ModifyEmployee
		(employeeGui, handleEmployee);
	    modifyEmployee.modifyAction("Display");
	}else{
	    employeeGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//displayEmployee
    
    void deleteEmployee(){
	if(action > 0){
	    employeeGui.setDefaultWindow("");
	    action--;
	    modifyEmployee = new ModifyEmployee
		(employeeGui, handleEmployee);
	    modifyEmployee.modifyAction("Delete");
	}else{
	    employeeGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//deleteEmployee
    
    void changeEmployee(){
	if(action > 0){
	    employeeGui.setDefaultWindow("");
	    action--;
	    modifyEmployee = new ModifyEmployee
		(employeeGui, handleEmployee);
	    modifyEmployee.modifyAction("Change");
	}else{
	    employeeGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//changeEmployee
}//HandleEmployee        

    
