// @(#)HandlePatient.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package control;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import gui.*;
import model.*;

public class HandlePatient implements KeyListener, MouseListener{
     
    public HandlePatient handlePatient;
    public PatientGui patientGui;
    
    //attributes that makes it posible to conduct action once
    // at the time
    public int action = 1;
    
    AddPatient addPatient;
    ModifyPatient modifyPatient;
    //constructor
    public HandlePatient(){
	init();
    }//HandlePatient
    
    private void init(){
    handlePatient = this;
    }
    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    
    //make the patient window
    public void makeWindow(){
	patientGui = new PatientGui();
	patientGui.createPatientGui();
	addExitWindowListener();
	addResetListeners();
	addOkListeners();
	addMainButtonListener();
	windowDestroy();
    }//makeWindow
    
    //when the window is destroyd whitout using the exitWindow button
    void windowDestroy(){
	patientGui.patientFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    patientGui.disposePatientGui();
		    if(modifyPatient != null){
			modifyPatient.patientSearch.disposePatientSearch();
		    }
		}//windowClosing
	    }); //addWindodlistener
    }//windowDestroy
    
    public void addResetListeners(){
	patientGui.resetWindowButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			if(action != 1){
			    action = 1;
			}
			patientGui.setDefaultWindow("");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
		
	    });
	
	patientGui.resetWindowButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			if(action != 1){
			    action = 1;
			}
			patientGui.setDefaultWindow("");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addResetListeners
    
    public void addExitWindowListener(){
	patientGui.exitWindowButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			patientGui.disposePatientGui();
			if(modifyPatient != null){
			    modifyPatient.patientSearch.
				disposePatientSearch();
			}
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.exitWindowButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			patientGui.disposePatientGui();
			if(modifyPatient != null){
			    modifyPatient.patientSearch.
				disposePatientSearch();
			}
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addExitWindowListeer
    
    //adds listeners to exitWindow and ok button in window PatientGui
    public void addOkListeners(){
	
	patientGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			patientGui.setInfoLabel("No action to perform!");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			patientGui.setInfoLabel("No action to perform!");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkExitWindowListener
    
    //adds listener to main button
    public void addMainButtonListener(){
	patientGui.addButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER ){
			addPatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.addButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			addPatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	patientGui.displayButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			displayPatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.displayButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			displayPatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	patientGui.deleteButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			deletePatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.deleteButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			deletePatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	patientGui.changeButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			changePatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientGui.changeButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			changePatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addMainButtonListener

    void addPatient(){
	if(action > 0){
	    patientGui.setDefaultWindow("");
	    action--;
	    addPatient = new AddPatient(patientGui, handlePatient);
	    addPatient.addAction();
	}else{
	    patientGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//addPatient
    
    void changePatient(){
	if(action > 0){
	    patientGui.setDefaultWindow("");
	    action--;
	    modifyPatient = new ModifyPatient(patientGui, handlePatient);
	    modifyPatient.modifyAction("Change");
	}else{
	    patientGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//changePatient
    
    void displayPatient(){
	if(action > 0){
	    patientGui.setDefaultWindow("");
	    action--;
	    modifyPatient = new ModifyPatient(patientGui, handlePatient);
	    modifyPatient.modifyAction("Display");
	}else{
	    patientGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//displayPatient
    
    void deletePatient(){
	if(action > 0){
	    patientGui.setDefaultWindow("");
	    action--;
	    modifyPatient = new ModifyPatient(patientGui, handlePatient);
	    modifyPatient.modifyAction("Delete");
	}else{
	    patientGui.setInfoLabel("Finish the already chosen action!");
	}//else
    }//deletePatient
}//HandlePatient






