// @(#)HandleResource.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package control;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import model.*;
import gui.*;

public class HandleResource implements KeyListener, MouseListener{
    
    
    ResourcesGui resources;
    SearchWindowGui searchWindowGui;
    HandleResource handleResource;
    ModifyResource modifyResource;
    AddResources addResources;
    String[] parameterString = new String[10];
    String functionChoice, function;
    String wardChoice, roomChoice, bedChoice;
    String choice;

    //counts how many searchWindow that is open.
    public int action = 1;
    
    //constructor
    public HandleResource(String s){
	handleResource = this;
    }
    
     // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}

    //create the resource window
    public void makeWindow(){
	resources = new ResourcesGui();
	resources.createResourcesGui();
	addTopButtonListeners();
	addBottomButtonsListeners();
	windowResourceDestroy();
    }//makeWindow
    
    //add listener for top buttons
    
    public void addTopButtonListeners(){
	
	//adds listener for bed button
	resources.bedButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if((e.getKeyCode() == KeyEvent.VK_ENTER) && 
		       (action > 0)){
			action--;
			choice = resources.bedButton.getText();
			createSearchWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	resources.bedButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK) && action > 0){
			choice = resources.bedButton.getText();
			action--;
			createSearchWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener

	//adds listener for room button
	resources.roomButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if((e.getKeyCode() == KeyEvent.VK_ENTER) && 
		       (action > 0)){
			choice = resources.roomButton.getText();
			action--;
			createSearchWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	resources.roomButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK) && (action > 0)){
			choice = resources.roomButton.getText();
			action--;
			createSearchWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener



	//adds listener for ward button
	resources.wardButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if((e.getKeyCode() == KeyEvent.VK_ENTER) && 
		       (action > 0)){
			choice = resources.wardButton.getText();
			action--;
			createSearchWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	resources.wardButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK) && (action > 0)){
			choice = resources.wardButton.getText();
			action--;
			createSearchWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addTopButtonListeners

    // a method that is used when the user want to create the 
    //popup window "searchWindow" that makes it possible to make a
    //choice
    public void createSearchWindow(){	
	resources.choice = choice;
	resources.setDefaultResourceWindow("");
	searchWindowGui = new SearchWindowGui(choice);
	searchWindowGui.createSearchGui();
	addFunctionChooseAction();
	addResetListeners();
	okExitWindowAction();
	windowDestroy();
    }//createSearchWindow
    
    //destroy SearchWindowGui
    void windowDestroy(){
	searchWindowGui.chooseFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    setWindowCount();
		}//windowClosing
	    }); //addWindodlistener
    }//windowDestroy

    //destroy ResearchGui
    void windowResourceDestroy(){
	resources.resourceFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    if(searchWindowGui != null){
			searchWindowGui.disposeSearchWindowGui();
		    }//if
		}//windowClosing
	    }); //addWindodlistener
    }//windowResourceDestroy
    
    //adds listener for bottom buttons
    public void addBottomButtonsListeners(){
	resources.exitWindowResourceButton.addKeyListener
	    (new KeyListener(){
		    public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER)
			    resources.disposeResourcesGui();
			if(searchWindowGui != null){
			    searchWindowGui.disposeSearchWindowGui();
			}//if
		    }
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
		});
	
	resources.exitWindowResourceButton.addMouseListener
	    (new MouseListener(){
		    public void mousePressed(MouseEvent e) {}
		    public void mouseReleased(MouseEvent e) {
			resources.disposeResourcesGui();
			if(searchWindowGui != null){
			    searchWindowGui.disposeSearchWindowGui();
			}//if
		    }
		    public void mouseEntered(MouseEvent e) {}
		    public void mouseExited(MouseEvent e) {}
		    public void mouseClicked(MouseEvent e) {}	
		});//addMouseListener
    }//addBottomButtonsListeners
    
    
    public void addResetListeners(){
	resources.resetWindowButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			if(action != 1){
			    action = 1;
			}
			resources.setDefaultResourceWindow("");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	resources.resetWindowButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			if(action != 1){
			    action = 1;
			}
			resources.setDefaultResourceWindow("");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addResetListeners
    
    // adds action to the comboBOx function
    public void addFunctionChooseAction(){
	searchWindowGui.functionCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			functionChoice =(String)cb.getSelectedItem();
			function = functionChoice;
			addAction();
		    }// if change
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
    searchWindowGui.functionCombo.putClientProperty
	("JComboBox.lightweightKeyboardNavigation","Lightweight");
    searchWindowGui.functionCombo.addActionListener
	(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			functionChoice =(String)cb.getSelectedItem();
			function = functionChoice;
			addAction();
		    }
		}
	    });
    }//addFunctionChooseAction
    
    void addAction(){
	StringTokenizer t = new StringTokenizer(function);
	function = t.nextToken();
	if(function.equals("Add")){
	    searchWindowGui.resetSearchGui();
	    searchWindowGui.removeOkCancelButton();
	    if(modifyResource != null){
		modifyResource = null;
	    }//if
	    if(addResources != null){
		addResources = null;
	    }
	    addResources = new AddResources
		(handleResource, searchWindowGui);
	    addResources.handleAddFunction(choice);
	}// if add
	if((function.equals("Change")) || 
	   (function.equals("Delete")) ||
	   (function.equals("Display"))){
	    searchWindowGui.resetSearchGui();
	    createModifyResource();
	    modifyResource.handleModifyFunction(choice);
	}// if change
    }//addAction
    
    //to avoid many pointers
    public void createModifyResource(){
	if(addResources != null){
	    searchWindowGui.removeOkCancelButton();
	    addResources = null;
	}//if
	if(modifyResource != null){
	    searchWindowGui.removeOkCancelButton();
	    modifyResource = null;
	}//if
	modifyResource = new ModifyResource
	    (handleResource, searchWindowGui);
    }//createModifyResource
    
    // resets windowCount
    public void setWindowCount(){
	action  = 1;
    }//setWindowCount 
       
    //adds listeners to ok and exitWindow button in the searchWindow
    public void okExitWindowAction(){
	searchWindowGui.cancelBeforeButton.addActionListener
	    (new ActionListener(){
		    public void actionPerformed(ActionEvent e) {
			searchWindowGui.disposeSearchWindowGui();
			setWindowCount();
			addResources = null;
		    } // actionPerformed
		});//addActionListener cancelChooseButton
	
	searchWindowGui.cancelBeforeButton.addKeyListener
	    (new KeyListener(){
		    public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
			    searchWindowGui.disposeSearchWindowGui();
			    setWindowCount();
			    addResources = null;
			}//if
		    }//keyPressed
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
		});
	
	// sets the action on ok button
	searchWindowGui.okBeforeButton.addActionListener
	    (new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    searchWindowGui.setInfoLabel("Make a choice!");
		} // actionPerformed
	    });//addActionListener cancelChooseButton
	
	searchWindowGui.okBeforeButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			searchWindowGui.setInfoLabel("Make a choice!");
		    }//if
		}//keyPressed
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });//okChhoseButton.addKeyListener
    }//okCanclAction
}//class HandleResource
