// @(#)MainHandler.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package control;

import java.io.*;
import java.awt.event.*;

import model.*;
import gui.*;


public class MainHandler implements KeyListener, MouseListener{

    static WardRegister wardRegister;
    static PatientRegister patientRegister;
    static EmployeeRegister employeeRegister;
    HssMain hssMain;
    MainHandler mainHandler;
    
    //constructorh
    public MainHandler(){
	wardRegister = new WardRegister();
	patientRegister = new PatientRegister();
	employeeRegister = new EmployeeRegister();
	mainHandler = this;
    }

    //Implements the KeyListener interface
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
	

    //adds listeners to the main window
    public void addListeners(HssMain h) {
	hssMain = h;
	h.mainFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    try{
		    tilFil();
		    }catch (IOException io){
			System.out.println("Noe gikk galt ved "+
					   "skriving til fil!");
		    }
		    System.exit(0);
		}//windowClosing
	    }); //addWindodlistener
	topButtonAction();
	bottomButtonAction();
    }//addListeners

    //create the main HSS window
    public void createMainWindow() throws Exception {
	try{
	    fraFil();
	}catch (IOException io){
	    System.out.println("Klarte ikke  lese fra fil!");
	}
	hssMain = new HssMain();
	hssMain.makeFrame();
	addListeners(hssMain);
    }//createrMainWindow
    
    //handels the action that happends
    
    public void topButtonAction(){
	hssMain.patientButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			HandlePatient handlePatient = new 
			    HandlePatient();
			handlePatient.makeWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	hssMain.patientButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {
		}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			HandlePatient handlePatient = new 
			    HandlePatient();
			handlePatient.makeWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener


	//resources
	hssMain.resourcesButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			HandleResource handleResource = 
			    new HandleResource
				(hssMain.resourcesButton.getText());
			handleResource.makeWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	hssMain.resourcesButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			HandleResource handleResource = 
			    new HandleResource
				(hssMain.resourcesButton.getText());
			handleResource.makeWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	//employee
		
	hssMain.employeeButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			HandleEmployee handleEmployee =
			    new HandleEmployee();
  			handleEmployee.makeWindow();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	hssMain.employeeButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			HandleEmployee handleEmployee =
			    new HandleEmployee();
  			handleEmployee.makeWindow();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener

	//operation
	hssMain.operationButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			hssMain.mainTextArea.setText("Functionality for " +
					     "'Operation' "+
					     "are not yet "+
					     "implemented! \n");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	hssMain.operationButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			hssMain.mainTextArea.setText("Functionality for "+
					     "'Operation' are not " +
					     "yet implemented! \n");
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//topButtonAction

    //bottomButtonAction
    public void bottomButtonAction(){
	
	hssMain.exitButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    try{
			tilFil();
		    }catch (IOException io){
			System.out.println("Noe gikk galt ved "+
					   "skriving til fil!");
		    }
		    System.exit(0);
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	hssMain.exitButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    try{
			tilFil();
		    }catch (IOException io){
			System.out.println("Noe gikk galt ved "+
					   "skriving til fil!");
		    }
		    System.exit(0);
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//bottomButtonAction

    public void tilFil() throws IOException {
	FileOutputStream   f  = new FileOutputStream("register.dta");
	ObjectOutputStream s  = new ObjectOutputStream(f);
	try{
	    System.out.println("Skriver til fil!");
	    s.writeObject(wardRegister);
	    s.writeObject(patientRegister);
	    s.writeObject(employeeRegister);
	    //s.writeObject(operationRegister);
	    s.flush();
	    s.close();
	}catch (IOException e){
	    System.out.println("Noe gikk galt ved skriving til fil!");
	}
    }//tilFil method
    
    public void fraFil() throws Exception {
	FileInputStream  ff  = new FileInputStream("register.dta");
	ObjectInputStream ss  = new ObjectInputStream(ff);
	try{
	    System.out.println("Leser fra fil!");
	    wardRegister = (WardRegister) ss.readObject();
	    patientRegister = (PatientRegister) ss.readObject();
	    employeeRegister = (EmployeeRegister) ss.readObject();
	    //operationRegister = (OperationRegister) ss.readObject();
	    ss.close();
	}catch (IOException e){
	    System.out.println("Klarte ikke  lese fra fil!");
	}
    }// fraFil method
}// class MainHandler 
