// @(#)ModifyEmployee.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package control;

import gui.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class ModifyEmployee implements KeyListener, MouseListener{

    EmployeeGui employeeGui;
    EmployeeSearch employeeSearch;
    HandleEmployee handleEmployee;
    String[][] employeeList;
    String[] changeList;
    String choice;
    String action;
    String birthNumber;

    public ModifyEmployee(EmployeeGui p, HandleEmployee h){
	employeeGui = p;
	handleEmployee = h;
    }
    
    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    
    public void modifyAction(String s){
	action = s;
	employeeSearch = new EmployeeSearch();
	employeeList = MainHandler.employeeRegister.getEmployees();
	String[] l = new String[employeeList.length];
	for(int i = 0; i < employeeList.length;i++){
	    l[i] = employeeList[i][0];
	}//for
	removeListeners();
	employeeSearch.createSearchGui(l);
	windowDestroy();
	addEmployeeComboListener();
	addOkCancelListeners();
	if(l.length > 0){ 
	    employeeSearch.employeeCombo.addMouseListener(this);
	}else{
	    employeeSearch.setInfoLabel("There exists no employees!");
	}
    }//modifyAction
    
    //when the window is destroyd whitout using the cancel button
    void windowDestroy(){
	employeeSearch.employeeFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    checkType(); 
		    handleEmployee.addOkListeners();
		}//windowClosing
	    }); //addWindodlistener
    }//windowDestroy
    
    //check what action and sets the variable in handleemployee
    void checkType(){
	if(action.equals("Display")){
	    handleEmployee.action++;
	}
	if(action.equals("Delete")){
	    handleEmployee.action++;
	}
	if(action.equals("Change")){
	    handleEmployee.action++;
	}
    }//checkType
    
    //adds listener to the ok and cancel button
    void addOkCancelListeners(){
	employeeSearch.cancelButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			cancelButton();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeSearch.cancelButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			cancelButton();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	employeeSearch.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			okButton();
		    }
		}
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
	    });
	
	employeeSearch.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			okButton();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkCancelListeners
    
    void cancelButton(){
	checkType();
	employeeSearch.disposeEmployeeSearch();
	handleEmployee.addOkListeners();
    }//cancelButton
    
    void okButton(){
	if(action.equals("Display")
	   && choice != null){
	    checkType();
	    String[] l = 
		MainHandler.employeeRegister.getEmployeeInfo(getFnr());
	    employeeGui.useEmployee(l, action);
	    employeeSearch.disposeEmployeeSearch();
	    handleEmployee.modifyEmployee = null;
	    handleEmployee.addOkListeners();
	}
	if(action.equals("Delete")
	   && choice != null){
	    checkType();
	    MainHandler.employeeRegister.deleteEmployee(getFnr());
	    employeeSearch.disposeEmployeeSearch();
	    handleEmployee.modifyEmployee = null;
	    employeeGui.setDefaultWindow("Employee '" + choice +
					 "' has been deleted!");
	    handleEmployee.addOkListeners();
	}
	if(action.equals("Change")
	   && choice != null){
	    checkType();
	    changeList = MainHandler.employeeRegister.
		getEmployeeInfo(getFnr());
	    employeeGui.useEmployee(changeList, action);
	    employeeSearch.disposeEmployeeSearch();
	    handleEmployee.modifyEmployee = null;
	    birthNumber = changeList[1];
	    addOkListener();
	}//if
    }//okButton
    
    String getFnr(){
	String fnr = "";
	for(int i = 0;i < employeeList.length; i++){
	    if(choice.equals(employeeList[i][0])){
		fnr = employeeList[i][1];
	    }
	}//for
	return fnr;
    }//getEmployee
    
    //adds listener to comboBox that the user choose employee from
    void addEmployeeComboListener(){
	employeeSearch.employeeCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			choice = (String)cb.getSelectedItem();
			employeeSearch.setInfoLabel
			    ("Press ok button to finish");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });

	employeeSearch.employeeCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	employeeSearch.employeeCombo.addActionListener
	    (new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			choice = (String)cb.getSelectedItem();
			employeeSearch.setInfoLabel
			    ("Press ok button to finish!");
		    }
		}
	    });
    }//addEmployeeComboListener
    
    void addOkListener(){ 
        employeeGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			okChange();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	employeeGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			okChange();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkListener
    
    void okChange(){
	String[] list = employeeGui.getChanges(changeList);
	list[6] = birthNumber;
	if(list != null){
	    MainHandler.employeeRegister.changeEmployee(list);
	}
    }//okChange

    //removes listener that is placed on okButton on EmployeeGui window
    void removeListeners(){
	MouseListener[] mls = (MouseListener[])
	    (employeeGui.okButton.getListeners(MouseListener.class));
	       
	for(int i = 0; i < mls.length;i++){
	    if(mls.length > 0){
		employeeGui.okButton.removeMouseListener(mls[i]);
	    }//if
	}//for
	
	KeyListener[] kls = (KeyListener[])
	    (employeeGui.okButton.getListeners(KeyListener.class));
	
	for(int i = 0; i < kls.length;i++){
	    if(mls.length > 0){
		employeeGui.okButton.removeKeyListener(kls[0]);
	    }//if
	}//for
    }//removeListeners
}//class ModifyEmployee
