// @(#)ModifyPatient.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package control;

import gui.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class ModifyPatient implements KeyListener, MouseListener{

    PatientGui patientGui;
    PatientSearch patientSearch;
    HandlePatient handlePatient;
    String[][] patientList;
    String[] changeList;
    String choice;
    String action;
    String birthNumber;
    
    public ModifyPatient(PatientGui p, HandlePatient h){
	patientGui = p;
	handlePatient = h;
    }
    
    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    
    public void modifyAction(String s){
	action = s;
	patientSearch = new PatientSearch();
	patientList = MainHandler.patientRegister.getPatients();
	String[] l = new String[patientList.length];
	for(int i = 0; i < patientList.length;i++){
	    l[i] = patientList[i][0];
	}//for
	removeListeners();
	patientSearch.createSearchGui(l);
	windowDestroy();
	addPatientComboListener();
	addOkCancelListeners();
	if(l.length == 0){
	    patientSearch.setInfoLabel("There exists no patients!");
	}
    }//modifyAction

    
    //when the window is destroyd whitout using the cancel button
    void windowDestroy(){
	patientSearch.patientFrame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e) {
		    checkType(); 
		    removeListeners();
		    handlePatient.addOkListeners();
		}//windowClosing
	    }); //addWindodlistener
    }//windowDestroy
    
    //check what action and sets the variable in handlepatient
    void checkType(){
	if(action.equals("Display")){
	    handlePatient.action++;
	}
	if(action.equals("Delete")){
	    handlePatient.action++;
	}
	if(action.equals("Change")){
	    handlePatient.action++;
	}
    }//checkType
    
    //adds listener to the ok and cancel button
    void addOkCancelListeners(){
	patientSearch.cancelButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			checkType();
			patientSearch.disposePatientSearch();
			handlePatient.addOkListeners();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	patientSearch.cancelButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			checkType();
			patientSearch.disposePatientSearch();
			handlePatient.addOkListeners();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
	
	patientSearch.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			okAction();
		    }
		}
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
	    });
	
	patientSearch.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			okAction();
		    }
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkCancelListeners
    
    void okAction(){
	if((action.equals("Display")) && (choice != null)){
	    checkType();
	    String[] l = MainHandler.patientRegister.
		getPatientInfo(getFnr());
	    patientGui.usePatient(l, action);
	    patientSearch.disposePatientSearch();
	    handlePatient.modifyPatient = null;
	    removeListeners();
	    handlePatient.addOkListeners();
	}
	if((action.equals("Delete")) && (choice != null)){
	    checkType();
	    MainHandler.patientRegister.deletePatient(getFnr());
	    patientSearch.disposePatientSearch();
	    handlePatient.modifyPatient = null;
	    patientGui.setDefaultWindow("Patient "+choice+
					" has been deleted!");
	    removeListeners();
	    handlePatient.addOkListeners();
	}
	if((action.equals("Change")) && (choice != null)){
	    checkType();
	    changeList = MainHandler.patientRegister.
		getPatientInfo(getFnr());
	    patientGui.usePatient(changeList, action);
	    patientSearch.disposePatientSearch();
	    handlePatient.modifyPatient = null;
	    addOkListener();
	    birthNumber = changeList[1];
	}
    }//okAction
    
    
    String getFnr(){
	String fnr = "";
	for(int i = 0;i < patientList.length; i++){
	    if(choice.equals(patientList[i][0])){
		fnr = patientList[i][1];
	    }
	}//for
	return fnr;
    }//getPatient
    
    //adds listener to comboBox that the user choose patient from
    void addPatientComboListener(){
	patientSearch.patientCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			choice = (String)cb.getSelectedItem();
			patientSearch.setInfoLabel
			    ("Press ok button to finish");
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });

	patientSearch.patientCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	patientSearch.patientCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			choice = (String)cb.getSelectedItem();
			patientSearch.setInfoLabel
			    ("Press ok button to finish!");
		    }
		}
	    });
    }//addPatientComboListener
    
    void addOkListener(){ 
    
    patientGui.okButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			modifyPatient();
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	});
	
	patientGui.okButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    if((e.getModifiers() & InputEvent.BUTTON1_MASK)
		       == InputEvent.BUTTON1_MASK){
			modifyPatient();
		    }//if
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addOkListener
    
    void modifyPatient(){
	String[] list = patientGui.getChanges(changeList);
	if(list != null){
	    list[5] = birthNumber; 
	    MainHandler.patientRegister.changePatient(list);
	}
	removeListeners();
	handlePatient.addOkListeners();
    }//modifyPatient
    
    void removeListeners(){
	MouseListener[] mls = (MouseListener[])
	    (patientGui.okButton.getListeners(MouseListener.class));
	       
	for(int i = 0; i < mls.length;i++){
	    if(mls.length > 0){
		patientGui.okButton.removeMouseListener(mls[i]);
	    }//if
	}//for
	
	KeyListener[] kls = (KeyListener[])
	    (patientGui.okButton.getListeners(KeyListener.class));
	
	for(int i = 0; i < kls.length;i++){
	    if(mls.length > 0){
		patientGui.okButton.removeKeyListener(kls[0]);
	    }//if
	}//for
    }//removeListeners
        
}//class ModifyPatient
