// @(#)ModifyResources.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package control;

import gui.*;
import model.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;


public class ModifyResource implements KeyListener, MouseListener {

    SearchWindowGui searchWindowGui;
    WardRegister wardRegister;
    HandleResource handleResource;
    ResourcesGui resourcesGui;
    
    String wardChoice;
    String roomChoice;
    String bedChoice;
    String[] changeList;
    String choice;

    //constructor
    public ModifyResource(HandleResource h, SearchWindowGui s){
    	handleResource = h;
	searchWindowGui = s;
	resourcesGui = h.resources;
    }//constructor

    // implements interface KeyListener
    public void keyTyped(KeyEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    
    //implement the MouseListener interface
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}


    //handles action: display, delete, change.
    public void handleModifyFunction(String s){
	choice = s;
	setWindow();
	getWardList();
	searchWindowGui.okCancelButton();
	okCancelAction();
	searchWindowGui.rePaint();
	if(resourcesGui.changeButton != null){
	    resourcesGui.bottomButtonsPanel.
		remove(resourcesGui.changeButton);
	}//if
    }//handleDisplayFunction
    
    //handles when action to be performed is delete
    public void handleDeleteFunction(){
	setWindow();
	getWardList();
	searchWindowGui.okCancelButton();
	okCancelAction();
	searchWindowGui.rePaint();
    }//handleDeleteFunction
    
    public void setWindow(){
	if(choice.equals("Bed")){
	searchWindowGui.setWardLabel("Choose ward");
	}
    }//setWindow
    
     //get list of wards.
    public void getWardList(){
	String[] list;
	list = MainHandler.wardRegister.getWardList();
	int length = list.length;
	if(length > 0){
	    searchWindowGui.setWardLabel("Choose ward");
	    searchWindowGui.putWard(list);
	    addWardListener();
	}//if
	else
	    searchWindowGui.setDefaultWindow("There exist no wards!");
    }//getWardList

    //adds listener to wardCombo
    public void addWardListener(){
	searchWindowGui.wardCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			wardChoice = (String)cb.getSelectedItem();
			if(choice.equals("Ward")){
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
			if(choice.equals("Room")){
			    searchWindowGui.removeFromBedWard();
			    boolean b = getRoomList();
			    if(b == true){
				searchWindowGui.setRoomLabel
				    ("Choose room");
			    }else{
				searchWindowGui.setInfoLabel
				    ("There exists no rooms!");
			    }//else
			}//if room
			if(choice.equals("Bed")){
			    searchWindowGui.removeFromBedWard();
			    boolean b = getRoomList();
			    if(b == true){
				searchWindowGui.setRoomLabel
				    ("Choose room");
				searchWindowGui.setInfoLabel("");
			    }else{
				searchWindowGui.setInfoLabel
				    ("There exists no rooms!");
			    }//else
			}//if bed
		    }//if
		}
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	searchWindowGui.wardCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	searchWindowGui.wardCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			wardChoice = (String)cb.getSelectedItem();
			if(choice.equals("Ward")){
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
			if(choice.equals("Room")){
			    searchWindowGui.removeFromBedWard();
			    boolean b = getRoomList();
			    if(b == true){
				searchWindowGui.setRoomLabel
				    ("Choose room");
			    }else{
				searchWindowGui.setInfoLabel
				    ("There exists no rooms!");
			    }//else
			}//if room
			if(choice.equals("Bed")){
			    searchWindowGui.removeFromBedWard();
			    boolean b = getRoomList();
			    if(b == true){
				searchWindowGui.setRoomLabel
				    ("Choose room");
				searchWindowGui.setInfoLabel("");
			    }else{
				searchWindowGui.setInfoLabel
				    ("There exists no rooms!");
			    }//else
			}//if bed
		    }
		}
	    });
    }//addWardListener

     public boolean getRoomList(){
	String[] list;
	boolean b = false;
	list = MainHandler.wardRegister.getRoomList(wardChoice);
	int length = list.length;
	if(length > 0){
	    searchWindowGui.putRoom(list);
	    addRoomListener();
	    b = true;
	}else{
	    searchWindowGui.setDefaultWindow("There exist no rooms!");
	    b = false;
	}
	return b;
    }//getRoomList
    
    public void addRoomListener(){
	searchWindowGui.roomCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			roomChoice = (String)cb.getSelectedItem();
			if(choice.equals("Room")){
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
			if(choice.equals("Bed")){
			    boolean bol;
			    searchWindowGui.removeFromBedRoom();
			    bol = getBedList();
			    
			    if(bol == false){
				searchWindowGui.setInfoLabel
				    ("There exists no beds!");
			    }else{
				searchWindowGui.setBedLabel
				    ("Choose bed");   
			    }//else
			}//if
		    }
		}//if
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });
	
	searchWindowGui.roomCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	searchWindowGui.roomCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			roomChoice = (String)cb.getSelectedItem();
			if(choice.equals("Room")){
			    searchWindowGui.setInfoLabel
				("Press ok button to finish");
			}
			if(choice.equals("Bed")){
			    boolean bol;
			    searchWindowGui.removeFromBedRoom();
			    bol = getBedList();
			    if(bol == false){
				searchWindowGui.setInfoLabel
				    ("There exists no beds!");
			    }else{
				searchWindowGui.setBedLabel
				    ("Choose bed");   
			    }//else
			}//if
		    }
		}
	    });
    }//addRoomListener
    
    //gets the bed from the chosen room
    public boolean getBedList(){
	String[] list;
	boolean bol = false;
	list = MainHandler.wardRegister.getBedList(wardChoice, roomChoice);
	int length = list.length;
	if(length > 0){
	    searchWindowGui.putBed(list);
	    addBedListener();
	    bol = true;
	}else{
	    bol = false;
	}//else
	return bol;
    }//getBedlist
    
    //adds listener for wardCombo
    public void addBedListener(){
	searchWindowGui.bedCombo.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			JComboBox cb = (JComboBox)e.getSource();
			bedChoice = (String)cb.getSelectedItem();
			searchWindowGui.setInfoLabel
			    ("Press ok button to finish");
		    }
		}//if
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
 	    });
	
	searchWindowGui.bedCombo.putClientProperty
	    ("JComboBox.lightweightKeyboardNavigation","Lightweight");
	searchWindowGui.bedCombo.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if(((e.getModifiers() & InputEvent.BUTTON1_MASK)
			== InputEvent.BUTTON1_MASK)){
			JComboBox cb = (JComboBox)e.getSource();
			bedChoice = (String)cb.getSelectedItem();
			searchWindowGui.setInfoLabel
			    ("Press ok button to finish");
		    }
		}
	    });
    }//addBedListener
    
    //adds action to cancel and ok button    
    public void okCancelAction(){
	searchWindowGui.cancelChooseButton.addActionListener
	    (new ActionListener(){
		    public void actionPerformed(ActionEvent e) {
			searchWindowGui.disposeSearchWindowGui();
			handleResource.setWindowCount();
			resourcesGui.setDefaultResourceWindow("");
			handleResource.modifyResource = null;
		    } // actionPerformed
		});//addActionListener cancelChooseButton
	
	searchWindowGui.cancelChooseButton.addKeyListener
	    (new KeyListener(){
		    public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
			    searchWindowGui.disposeSearchWindowGui();
			    handleResource.setWindowCount();
  			    resourcesGui.setDefaultResourceWindow("");
			    handleResource.modifyResource = null;
			}//if
		    }//keyPressed
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
		});
	
	// sets the action on ok button
	searchWindowGui.okChooseButton.addActionListener
	    (new ActionListener(){
		    public void actionPerformed(ActionEvent e) {
			if(handleResource.function.equals("Delete")){
			    deleteChoice();
			    handleResource.modifyResource = null;
			}//if
			if(handleResource.function.equals("Display")){
			    displayChoice();
			    handleResource.modifyResource = null;
			}//if
		      if(handleResource.function.equals("Change")){
			    changeChoice();
			    handleResource.modifyResource = null;
			}//if
		    } // actionPerformed
		});//addActionListener cancelChooseButton
	
	searchWindowGui.okChooseButton.addKeyListener(new KeyListener(){
		public void keyPressed(KeyEvent e) {
		    if(e.getKeyCode() == KeyEvent.VK_ENTER){
			if(handleResource.function.equals("Delete")){
			    deleteChoice();
			    handleResource.modifyResource = null;
			}//if
			if(handleResource.function.equals("Display")){
			    displayChoice();
			    handleResource.modifyResource = null;
			}//if
			if(handleResource.function.equals("Change")){
			    changeChoice();
			    handleResource.modifyResource = null;
			}//if
		    }//if
		}//keyPressed
		public void keyTyped(KeyEvent event) {}
		public void keyReleased(KeyEvent event){}
	    });//okChhoseButton.addKeyListener
    }//okCancelAction
    
    //add listener to change button on ResourcesGui.
    public void addChangeListener(){
	resourcesGui.changeButton.addKeyListener
	    (new KeyListener(){
		    public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
			    String[] list = resourcesGui.getChanges
				(changeList); 
			    if((list != null) && (choice.equals("Ward"))){
				MainHandler.wardRegister.changeWard
				    (wardChoice, list);
			    }
			    if((list != null) && (choice.equals("Room"))){
				MainHandler.wardRegister.changeRoom
				    (wardChoice, roomChoice, list);
			    }
			    if((list != null) && (choice.equals("Bed"))){
				MainHandler.wardRegister.changeBed
				    (wardChoice, roomChoice, bedChoice, 
				     list);
			    }//if
			}//if
		    }//keyPressed
		    public void keyTyped(KeyEvent event) {}
		    public void keyReleased(KeyEvent event){}
		});
	
	resourcesGui.changeButton.addMouseListener(new MouseListener(){
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {
		    String[] list = resourcesGui.getChanges(changeList); 
		    if((list != null) && (choice.equals("Ward"))){
			MainHandler.wardRegister.changeWard
			    (wardChoice, list);
		    }
		    if((list != null) && (choice.equals("Room"))){
			MainHandler.wardRegister.changeRoom
			    (wardChoice, roomChoice, list);
		    }
		    if((list != null) && (choice.equals("Bed"))){
			MainHandler.wardRegister.changeBed
			    (wardChoice, roomChoice, bedChoice, 
			     list);
		    }
		}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mouseClicked(MouseEvent e) {}	
	    });//addMouseListener
    }//addChangeListener
    
    //performed when change is the function
    public void changeChoice(){
	if(choice.equals("Ward")){
	    if(wardChoice != null){
		changeList = MainHandler.wardRegister.displayWard
		    (wardChoice);
		resourcesGui.displayInfo(changeList[0], changeList[1],
					 changeList[2], " ");
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setInfoLabel
		    ("Change information on ward "+ wardChoice
		     +" and press the change button!");
		resourcesGui.setLayoutField();
		resourcesGui.addChangeButton();
		addChangeListener();
	    }else{
	    searchWindowGui.setInfoLabel
		("There exists no ward to change!");
	    }//else
	}//if
	
	if(choice.equals("Room")){
	    if((wardChoice != null) && (roomChoice != null)){
		changeList = MainHandler.wardRegister.displayRoom
		    (wardChoice, roomChoice);
		resourcesGui.displayInfo(changeList[0], changeList[1],
					 changeList[2], changeList[3]);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setInfoLabel
		("Change information on room "+ roomChoice
		     +" and press the change button!");
		resourcesGui.setWardLabel("Ward: " +wardChoice);
		resourcesGui.setRoomLabel("");
		resourcesGui.setLayoutField();
		resourcesGui.addChangeButton();
		addChangeListener();
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no room to change!");
	    }
	}//if Room
	
	if(choice.equals("Bed")){
	    if((wardChoice != null) && (roomChoice != null) &&
	       (bedChoice != null)){
		changeList = MainHandler.wardRegister.displayBed
		    (wardChoice, roomChoice, bedChoice);
		resourcesGui.setLayoutField();
		resourcesGui.displayInfo(changeList[0], changeList[1],
					 changeList[2], changeList[3]);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setInfoLabel
		    ("Change information on bed "+ bedChoice
		     +" and press the change button!");
		resourcesGui.setWardLabel("Ward: " +wardChoice);
		resourcesGui.setRoomLabel("Room: " +roomChoice);
		resourcesGui.addChangeButton();
		addChangeListener();
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no room to change!");
	    }//else
	}//if Room
    }//changeChoice

    //preformed when display is the function
    public void displayChoice(){
	String[] list;
	if(choice.equals("Ward")){
	    if(wardChoice != null){
		list = MainHandler.wardRegister.displayWard(wardChoice);
		resourcesGui.setInfoLabel
		    ("Displaying ward "+ wardChoice +"!");
		resourcesGui.displayInfo(list[0], list[1],
					 list[2], " ");
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no ward to display!");
	    }//else
	}//if ward
	
	if(choice.equals("Room")){
	    if((wardChoice != null) && (roomChoice != null)){
		list = MainHandler.wardRegister.displayRoom
		    (wardChoice, roomChoice);
		resourcesGui.setInfoLabel
		    ("Displaying room "+ roomChoice +"!");
		resourcesGui.setWardLabel("Ward: " +wardChoice);
		resourcesGui.setRoomLabel("");
		resourcesGui.displayInfo(list[0], list[1],
					 list[2], list[3]);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no room to display!");
	    }
	}//if Room
	
	if(choice.equals("Bed")){
	    if((wardChoice != null) && (roomChoice != null) &&
	       (bedChoice != null)){
		list = MainHandler.wardRegister.displayBed
		    (wardChoice, roomChoice, bedChoice);
		resourcesGui.setInfoLabel
		    ("Displaying bed "+ bedChoice+"!");
		resourcesGui.setWardLabel
		    ("Ward: " +wardChoice);
		resourcesGui.setRoomLabel
		    ("Room: " +roomChoice);
		resourcesGui.displayInfo(list[0], list[1],
					 list[2], list[3]);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no room to display!");
	    }//else
	}//if Room
    }//displayChoice

    //preformed when delete is the function
    public void deleteChoice(){
	if(choice.equals("Ward")){
	    if(wardChoice != null){
		MainHandler.wardRegister.removeWard(wardChoice);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setDefaultResourceWindow
		    ("Ward '"+ wardChoice +  "' has been deleted!");
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no ward to delete!");
	    }//else
	}//if ward
	
	if(choice.equals("Room")){
	    if((wardChoice != null) && (roomChoice != null)){
		MainHandler.wardRegister.removeRoom(wardChoice,roomChoice);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setDefaultResourceWindow
		    ("Room '"+ roomChoice +"' has been deleted!");
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no room to delete!");
	    }//else
	}//if Room
	
	if(choice.equals("Bed")){
	    if((wardChoice != null) && (roomChoice != null) &&
	       (bedChoice != null)){
		MainHandler.wardRegister.
		    removeBed(wardChoice, roomChoice, bedChoice);
		searchWindowGui.disposeSearchWindowGui();
		handleResource.setWindowCount();
		resourcesGui.setDefaultResourceWindow
		    ("Bed '"+ bedChoice +"' has been deleted!");
	    }else{
		searchWindowGui.setInfoLabel
		    ("There exists no bed to delete!");
	    }//else
	}//if Room
    }//deleteChoice
}//class ModifyResource

