// @(#)EmployeeGui.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.lang.*;
import java.awt.*;
import control.*;

public class EmployeeGui {
    
    final JLabel frameLabel 
	= new JLabel("Welcome to the 'Employee'  window. Please choose a"+
		   " function!");
    public JFrame employeeFrame;
    JPanel employeePanel;
    GridBagLayout employeeGridbag;
    GridBagConstraints gridBagConstraints;
    GridBagConstraints employeesConstraints;

    public JButton addButton;
    public JButton displayButton;
    public JButton deleteButton;
    public JButton changeButton;
    final Insets buttonSize = new Insets(25, 25, 25, 25);
    
    public JButton exitWindowButton;
    public JButton resetWindowButton;
    public JButton okButton;
    
    JLabel nameLabel;
    JLabel fnrLabel;
    JLabel addressLabel;
    JLabel phoneLabel;
    JLabel pagerNumberLabel;
    JLabel typeLabel;
    JLabel kindOfLabel; 
    JLabel typeInfoLabel;
    JLabel kindOfInfoLabel;
    JLabel infoLabel;
    JLabel fnrInfoLabel;
    JTextField nameTextField;
    JTextField fnrTextField;
    JTextField addressTextField;
    JTextField phoneTextField;
    JTextField pagerNumberTextField;
    JTextField typeTextField;
    JTextField kindOfTextField;
    Rectangle bounds;
    
    //bottom stuff
    GridBagLayout bottomGridBag;
    GridBagConstraints bottomConstraints;
    JPanel bottomButtonsPanel;
    
    //constructor
    public EmployeeGui(){
    }
    
    public void createEmployeeGui(){
	frameLabel.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
	bounds = new Rectangle();
	GraphicsEnvironment ge = GraphicsEnvironment.
	    getLocalGraphicsEnvironment();
	GraphicsDevice gs = ge.getDefaultScreenDevice();
	GraphicsConfiguration gc = gs.getDefaultConfiguration();
	employeeFrame = new JFrame("Employee", gc);
	bounds = gc.getBounds();
	employeeGridbag = new GridBagLayout();
	employeePanel = new JPanel(employeeGridbag);
	employeesConstraints = new GridBagConstraints();
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 0;
	employeesConstraints.gridwidth = 4;
	employeeGridbag.setConstraints(frameLabel, employeesConstraints);
	employeePanel.add(frameLabel);
	createTopButtons();
	createFields();
	createBottomButtons();

	employeeFrame.getContentPane().add(this.employeePanel);

	employeeFrame.setResizable(false);
	employeeFrame.pack();
	employeeFrame.setLocation(50 + bounds.x, 500 + bounds.y);
	employeeFrame.show();
	employeeFrame.setVisible(true);
	employeeFrame.repaint(1);
    }//createEmployeeGui

    //creates top buttons and add them to the window
    void createTopButtons(){
	addButton = new JButton("Add");
	changeButton = new JButton("Change");
	deleteButton = new JButton("Delete");
	displayButton = new JButton("Display");
	JPanel topButtonsPanel = new JPanel();
	// setBorder on JPanel
	topButtonsPanel.setBorder(
	    BorderFactory.createCompoundBorder(
		   		BorderFactory.createCompoundBorder(
		      BorderFactory.createTitledBorder("Choose between!"), 
		      BorderFactory.createEmptyBorder(5,5,5,5)),
				topButtonsPanel.getBorder()));
	
	//setBorder
	addButton.setMargin(buttonSize);
	changeButton.setMargin(buttonSize);
	deleteButton.setMargin(buttonSize);
	displayButton.setMargin(buttonSize);
	//add buttons
	topButtonsPanel.add(addButton);
	topButtonsPanel.add(changeButton);
	topButtonsPanel.add(deleteButton);
	topButtonsPanel.add(displayButton);
	
	employeesConstraints.gridx = 0;
	employeesConstraints.gridy = 1;
	employeesConstraints.gridwidth = 4;
	employeeGridbag.setConstraints(topButtonsPanel, 
			       employeesConstraints);
	employeePanel.add(topButtonsPanel);
    }//createTOpButtons
    
    //create fields but do NOT add them on
    void createFields(){
	infoLabel = new JLabel("");
	infoLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 2;
	employeesConstraints.gridwidth = 4;
	employeeGridbag.setConstraints(infoLabel, employeesConstraints);

	nameLabel = new JLabel("Name:       ");
	nameLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 3;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(nameLabel, employeesConstraints);
	
	nameTextField = new JTextField(15);
	nameTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 3;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(nameTextField, 
				       employeesConstraints);
	
	fnrLabel = new JLabel("Birth number:");
	fnrLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 4;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(fnrLabel, employeesConstraints);
	
	fnrTextField = new JTextField(15);
	fnrTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 4;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(fnrTextField, 
				       employeesConstraints);

	fnrInfoLabel = new JLabel("");
	fnrInfoLabel.setBorder
	    (BorderFactory.createEmptyBorder(10,10,10,10));
	employeesConstraints.gridx = 3;
       	employeesConstraints.gridy = 4;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(fnrInfoLabel, employeesConstraints);

	
	addressLabel = new JLabel("Address:      ");
	addressLabel.setBorder(BorderFactory.
			      createEmptyBorder(10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 5;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(addressLabel, 
				       employeesConstraints);
	
	addressTextField = new JTextField(15);
	addressTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 5;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(addressTextField, 
				       employeesConstraints);
	
	phoneLabel = new JLabel("Phone:       ");
	phoneLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 6;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(phoneLabel, 
				       employeesConstraints);
	
	phoneTextField = new JTextField(15);
	phoneTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 6;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(phoneTextField, 
				       employeesConstraints);
	
	pagerNumberLabel = new JLabel("PagerNumber:     ");
	pagerNumberLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 7;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(pagerNumberLabel, 
				       employeesConstraints);
	
	pagerNumberTextField = new JTextField(15);
	pagerNumberTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 7;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(pagerNumberTextField, 
				       employeesConstraints);
	
	kindOfLabel = new JLabel("Kind of:     ");
	kindOfLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 9;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(kindOfLabel, 
				       employeesConstraints);
	
	kindOfTextField = new JTextField(15);
	kindOfTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 9;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(kindOfTextField, 
				       employeesConstraints);

	kindOfInfoLabel = new JLabel("");
	kindOfInfoLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 3;
       	employeesConstraints.gridy = 9;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(kindOfInfoLabel, 
				       employeesConstraints);

	
	typeLabel = new JLabel("Type:     ");
	typeLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 8;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(typeLabel, 
				       employeesConstraints);

	typeInfoLabel = new JLabel("");
	typeInfoLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	employeesConstraints.gridx = 3;
       	employeesConstraints.gridy = 8;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(typeInfoLabel, 
				       employeesConstraints);

	typeTextField = new JTextField(15);
	typeTextField.setEditable(false);
	employeesConstraints.gridx = 1;
       	employeesConstraints.gridy = 8;
	employeesConstraints.gridwidth = 1;
	employeeGridbag.setConstraints(typeTextField, 
				       employeesConstraints);

	employeePanel.add(infoLabel);
	employeePanel.add(nameLabel);
  	employeePanel.add(fnrLabel);
  	employeePanel.add(addressLabel);
  	employeePanel.add(phoneLabel);
	employeePanel.add(pagerNumberLabel);
	employeePanel.add(kindOfLabel);
	employeePanel.add(kindOfInfoLabel);
	employeePanel.add(typeLabel);
	employeePanel.add(typeInfoLabel);
	employeePanel.add(fnrInfoLabel);
	employeePanel.add(nameTextField);
	employeePanel.add(fnrTextField);
	employeePanel.add(addressTextField);
	employeePanel.add(phoneTextField);
	employeePanel.add(pagerNumberTextField);
	employeePanel.add(kindOfTextField);
	employeePanel.add(typeTextField);
	nameTextField.setEditable(false);
	fnrTextField.setEditable(false);
	addressTextField.setEditable(false);
	phoneTextField.setEditable(false);
	pagerNumberTextField.setEditable(false);
	kindOfTextField.setEditable(false);
	typeTextField.setEditable(false);
    }//createFields
    
    //add exitWindow and ok buttons to the window
    public void createBottomButtons(){
	exitWindowButton = new JButton("Exit Window");
	okButton = new JButton("Ok");
	resetWindowButton = new JButton("Reset Window");

	bottomGridBag = new GridBagLayout();
	bottomConstraints = new GridBagConstraints();
	bottomButtonsPanel = new JPanel(bottomGridBag);
	
	bottomConstraints.gridx = 2;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(exitWindowButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(exitWindowButton);

	bottomConstraints.gridx = 3;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(resetWindowButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(resetWindowButton);
	
	employeesConstraints.gridx = 0;
       	employeesConstraints.gridy = 10;
	employeesConstraints.gridwidth = 4;
	employeeGridbag.setConstraints(bottomButtonsPanel, 
				       employeesConstraints);
	employeePanel.add(bottomButtonsPanel);
    }//createBottomButtons
    
    //when user push add button this method is used from class AddEmployee
    public void addAction(){
	infoLabel.setText("Fill in all fields and press the 'Ok' "+
			  "button");
	fnrInfoLabel.setText("Birth number must be eleven digits");
	kindOfInfoLabel.setText("Employees specialization");
	typeInfoLabel.setText("Type must be: 'Doctor' or 'Nurse'");
       	nameTextField.setEditable(true);
	fnrTextField.setEditable(true);
	addressTextField.setEditable(true);
	phoneTextField.setEditable(true);
	pagerNumberTextField.setEditable(true);
	kindOfTextField.setEditable(true);
	typeTextField.setEditable(true);
	bottomConstraints.gridx = 1;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(okButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(okButton);
	employeeFrame.pack();
	employeeFrame.repaint(1);
	employeeFrame.setLocation(50 + bounds.x, 500 + bounds.y);
    }//addEmployee
    
    //returns a String[] with the information in the 
    //EmployeeGuis window.
    public String[] getInfo(){
	String[] list = new String[7];
	list[0] = nameTextField.getText();
	list[1] = fnrTextField.getText();
	list[2] = addressTextField.getText();
	list[3] = phoneTextField.getText();
	list[4] = pagerNumberTextField.getText();
	list[5] = kindOfTextField.getText();
	list[6] = typeTextField.getText();
	return list;
    }//getInfo

    //set window to default
    public void setDefaultWindow(String s){
	nameTextField.setEditable(false);
	fnrTextField.setEditable(false);
	addressTextField.setEditable(false);
	phoneTextField.setEditable(false);
	pagerNumberTextField.setEditable(false);
	kindOfTextField.setEditable(false);
	typeTextField.setEditable(false);
	typeInfoLabel.setText("");
	infoLabel.setText(s);
	kindOfInfoLabel.setText("");
	fnrInfoLabel.setText("");
	nameTextField.setText("");
	fnrTextField.setText("");
	addressTextField.setText("");
	phoneTextField.setText("");
	pagerNumberTextField.setText("");
	kindOfTextField.setText("");
	typeTextField.setText("");
	bottomButtonsPanel.remove(okButton);
	employeeFrame.repaint(1);
    }//setDefaultWindow

    //sets the window with the information in String[] list
    //and performe "change" or "display" depending on what String s is
    public void useEmployee(String[] list, String s){
	boolean use = false;
	if(s.equals("Change")){
	    use = true;
	    infoLabel.setText("Change information on employee '"+
			      list[0]+"' and press ok!");
	    fnrInfoLabel.setText("Birth number must be eleven digits");
	    kindOfInfoLabel.setText("Employees specialization");
	    bottomConstraints.gridx = 1;
	    bottomConstraints.gridy = 0;
	    bottomGridBag.setConstraints(okButton, 
					 bottomConstraints);
	    bottomButtonsPanel.add(okButton);
	}else{
	    infoLabel.setText("Displaying employee '"+list[0]+"'");
	}//else
	
	nameTextField.setEditable(use);
	fnrTextField.setEditable(use);
	addressTextField.setEditable(use);
	phoneTextField.setEditable(use);
	pagerNumberTextField.setEditable(use);
	kindOfTextField.setEditable(use);
	nameTextField.setText(list[0]);
	fnrTextField.setText(list[1]);
	addressTextField.setText(list[2]);
	phoneTextField.setText(list[3]);
	pagerNumberTextField.setText(list[4]);
	kindOfTextField.setText(list[5]);
	typeTextField.setText(list[6]);
	employeeFrame.pack();
	employeeFrame.repaint(1);
	employeeFrame.setLocation(50 + bounds.x, 500 + bounds.y);
    }//useEmployee
    
    public void setInfoLabel(String s){
	infoLabel.setText(s);
	employeeFrame.pack();
	employeeFrame.repaint(1);
	employeeFrame.setLocation(50 + bounds.x, 500 + bounds.y);
    }//setInfoLabel

    //gets and sets the changes done
    public String[] getChanges(String[] list){
	int a = 0;
	int b = 0;
	int c = 0;
	int d = 0;
	int e = 0;
	int f = 0;
	String[] changeList = list;
	
	if(fnrTextField.getText().length() != 11){
	    setInfoLabel("Birth number must be eleven digits!");
	}else{
	    if(list[0].equals(nameTextField.getText())){
		a = 0;
	    } else{
		changeList[0] = nameTextField.getText();
		a = 1;
	    }
	    if(list[1].equals(fnrTextField.getText())){
		b = 0;
	    } else{
		b = 1;
		changeList[1] = fnrTextField.getText();
	    }
	    if(list[2].equals(addressTextField.getText())){
		c = 0;
	    } else{
		c = 1;
		changeList[2] = addressTextField.getText();
	    }
	    if(list[3].equals(phoneTextField.getText())){
		d = 0;
	    } else{
	    d = 1;
	    changeList[3] = phoneTextField.getText();
	    }
	    if(list[4].equals(pagerNumberTextField.getText())){
		e = 0;
	    } else{
		e = 1;
	    changeList[4] = pagerNumberTextField.getText();
	    }
	    if(list[5].equals(kindOfTextField.getText())){
		f = 0;
	    } else{
		f = 1;
	    changeList[5] = kindOfTextField.getText();
	    }
	    
	    if((a == 0) && (b == 0) && (c == 0) && (d == 0)
	       && (e == 0) && (f == 0)){
		setInfoLabel("No change made to the choosen employee!");
	    }else{
		setDefaultWindow("Change information has been performed!");
		return changeList;
	    }//else
	}//else
	changeList = null;
	return changeList;
    }//getChanges
    
    public void disposeEmployeeGui(){
	employeeFrame.dispose();
    }//disposeEmployeeGui
}//EmployeeGui
