// @(#)EmployeeSearch.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.lang.*;
import java.awt.*;

public class EmployeeSearch{
    
    //builds up the windows for employeeResources
    public JFrame employeeFrame;
    JPanel employeePanel;
    GridBagLayout employeeGrid;
    GridBagConstraints employeeConstraint;
    public JButton okButton;
    public JButton cancelButton;
    JLabel employeeLabel;
    public JComboBox employeeCombo;
    public JLabel foo1Label;
    public JLabel foo2Label;
    public JLabel foo3Label;
    Dimension sizeCombo;
    public JLabel infoLabel = new JLabel(" ");
    Rectangle bounds;
    
   public EmployeeSearch(){
    }

    public void createSearchGui(String [] list){
	 bounds = new Rectangle();
	 GraphicsEnvironment ge = GraphicsEnvironment.
	     getLocalGraphicsEnvironment();
	 GraphicsDevice gs = ge.getDefaultScreenDevice();
	 GraphicsConfiguration gc = gs.getDefaultConfiguration();
	 employeeFrame = new JFrame("Choose employee!", gc);
	 bounds = gc.getBounds();
	 employeePanel = new JPanel();
	 employeeGrid = new GridBagLayout();
	 employeeConstraint = new GridBagConstraints();
	 okButton = new JButton("OK");
	 cancelButton = new JButton("Cancel"); 
	 employeePanel.setLayout(employeeGrid);
	 employeeCombo = new JComboBox(list);
	 employeeLabel = new JLabel("Choose a employee");
	 sizeCombo = new Dimension(120, 45);
	 createDropDownList();
	 createLabel();
	 
	 //infoLabel
	 employeeConstraint.gridx = 0;
	 employeeConstraint.gridy = 3;
	 employeeConstraint.gridwidth = 2;
	 infoLabel.setBorder(BorderFactory.createEmptyBorder
			     (10,10,10,10));
	 employeeGrid.setConstraints(infoLabel, employeeConstraint);
	 employeePanel.add(infoLabel);

	 employeeConstraint.gridx = 0;
	 employeeConstraint.gridy = 4;
	 employeeGrid.setConstraints(okButton, employeeConstraint);
	 employeePanel.add(okButton);

	 employeeConstraint.gridx = 1;
	 employeeConstraint.gridy = 4;
	 employeeGrid.setConstraints(cancelButton, employeeConstraint);
	 employeePanel.add(cancelButton);
	 
	 employeeFrame.getContentPane().add(employeePanel);
	 employeeFrame.pack();
	 employeeFrame.setLocation(100 + bounds.x, 650 + bounds.y);
	 employeeFrame.show();
	 employeeFrame.setVisible(true);
	 employeeFrame.repaint(1);
     }// createSearchGui 

    //Paint or rePaint the window
    public void rePaint(){
	employeeFrame.pack();
	employeeFrame.repaint(1);
	employeeFrame.setLocation(100 + bounds.x, 650 + bounds.y);
    }//rePaint

    //add default blank labels to the window
    public void createLabel(){
	foo1Label = new JLabel("");
	foo2Label = new JLabel("");
	//label foo1
	foo1Label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
  	employeeConstraint.gridx = 0;
  	employeeConstraint.gridy = 1;
  	employeeGrid.setConstraints(foo1Label, employeeConstraint);
  	employeePanel.add(foo1Label);
	//label foo2
	foo2Label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	employeeConstraint.gridx = 0;
	employeeConstraint.gridy = 2;
	employeeGrid.setConstraints(foo2Label, employeeConstraint);
	employeePanel.add(foo2Label);
    }//createLabel

    //create drop down list
    public void createDropDownList(){
	//borders
	employeeCombo.setBorder(BorderFactory.createEmptyBorder
				(10,10,20,10));
	employeeLabel.setBorder(BorderFactory.createEmptyBorder
				(10,10,20,10));
	//label
	employeeConstraint.gridx = 0;
	employeeConstraint.gridy = 0;
	employeeConstraint.gridwidth = 1;
	employeeGrid.setConstraints(employeeLabel, 
				       employeeConstraint);
	employeePanel.add(employeeLabel);
	//combo
	employeeConstraint.gridx = 1;
	employeeConstraint.gridy = 0;
	employeeConstraint.gridwidth = 1;
	employeeGrid.setConstraints(employeeCombo, 
				       employeeConstraint);
	employeePanel.add(employeeCombo);
    }//createDropDownList

    public void setInfoLabel(String s){
	infoLabel.setText(s);
    }

    public void disposeEmployeeSearch(){
	employeeFrame.dispose();
    }//disposeEmployeeSearch
}//class searchGui
