// @(#)HssMain.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import control.*;

public class HssMain {

   // local variabels that make up the main window
    public JFrame mainFrame;
    final JLabel mainLabel = 
	new JLabel("Welcome to the Hospital " +
		   "Scheduling System. Please choose an action!");
    final Insets buttonSize= new Insets(25, 25, 25, 25);
    JScrollPane mainScrollPane;
    public JTextArea mainTextArea;
    JPanel mainButtonsPanel;
    public JButton exitButton;

    JPanel southPanel;

    //buttons
    public JButton patientButton;
    public JButton resourcesButton;
    public JButton operationButton;
    public JButton employeeButton;
    
    HssMain mother;
        
    // constructor
    public HssMain(){
  	mother = this;
    }//constructor

    //method that makes the main window.
    public void createMainWindow() {
	GridBagLayout south = new GridBagLayout();
	southPanel = new JPanel(south);
	GridBagConstraints southC = new GridBagConstraints();
	
	//Makes the four mainButtons that are in the window
        patientButton = new JButton("Patient");
        resourcesButton = new JButton("Resources");
	employeeButton = new JButton("Employee");
	operationButton = new JButton("Operation");
	
	//exit
	exitButton = new JButton("Exit system");
	
	mainLabel.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
	
	// Makes the text area that display information at startup
 
	mainTextArea = new JTextArea(5, 35);
	mainTextArea.setEditable(false);
	mainTextArea.setBackground(Color.lightGray);
	mainTextArea.setLineWrap(true);
	mainTextArea.setWrapStyleWord(true);
	mainTextArea.setFont(new Font("Dialog", Font.PLAIN,14));
	mainTextArea.append("If you want to work on a patient; " +
			    "press patient button. \n");
	mainTextArea.append("If you want to work on a employee; " +
			    "press employee button. \n");
	mainTextArea.append("If you want to work on a resource; " +
			    "press resource button. \n");
	mainTextArea.append("If you want to work on an operation; " + 
			    "press operation button. \n");
	mainScrollPane = new JScrollPane(mainTextArea);
	mainScrollPane.setVerticalScrollBarPolicy
	    (JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	mainScrollPane.setBorder(
	    BorderFactory.createCompoundBorder(
		   		BorderFactory.createCompoundBorder(
			  BorderFactory.createTitledBorder("Information"), 
		          BorderFactory.createEmptyBorder(5,5,5,5)),
		mainScrollPane.getBorder()));
	
	southC.gridx = 0;
  	southC.gridy = 0;
  	southC.gridwidth = 4;
  	south.setConstraints(mainScrollPane, southC);
	southPanel.add(mainScrollPane);
	
	JPanel button = new JPanel();
	button.setLayout(new BoxLayout(button, BoxLayout.X_AXIS));
	button.add(exitButton);
	southC.gridx = 1;
  	southC.gridy = 2;
  	south.setConstraints(button, southC);
  	southPanel.add(button);
	
	// Constructs a panel to add the three buttons on and sets a 
	//nice border for them 
	
	mainButtonsPanel = new JPanel();
	mainButtonsPanel.setBorder(
	    BorderFactory.createCompoundBorder(
		   		BorderFactory.createCompoundBorder(
		      BorderFactory.createTitledBorder("Choose between!"), 
		      BorderFactory.createEmptyBorder(5,5,5,5)),
				mainButtonsPanel.getBorder()));

	// set the buttonsize
	patientButton.setMargin(buttonSize);
	operationButton.setMargin(buttonSize);
	resourcesButton.setMargin(buttonSize);
	employeeButton.setMargin(buttonSize);
	
	// add buttons to the panel
	mainButtonsPanel.add(patientButton);
	mainButtonsPanel.add(employeeButton);
	mainButtonsPanel.add(resourcesButton);
	mainButtonsPanel.add(operationButton);
    }//createMainWindow
    
    public void makeFrame(){

	Rectangle bounds = new Rectangle();
	GraphicsEnvironment ge = GraphicsEnvironment.
	    getLocalGraphicsEnvironment();
	GraphicsDevice gs = ge.getDefaultScreenDevice();
        
	GraphicsConfiguration gc = gs.getDefaultConfiguration();
	mainFrame = new JFrame("Hospital Scheduling System", gc);
	bounds = gc.getBounds();
	mainFrame.setLocation(bounds.x, 220 + bounds.y);
	mother.createMainWindow();
	mainFrame.setResizable(false);
	mainFrame.getContentPane().add(mother.mainButtonsPanel, 
				       BorderLayout.CENTER);
	mainFrame.getContentPane().add(mother.mainLabel, 
				       BorderLayout.NORTH);
	mainFrame.getContentPane().add
	    (mother.southPanel, BorderLayout.SOUTH);
	mainFrame.pack();
	mainFrame.show();
	mainFrame.setVisible(true);   
    }
} // class HSS




















