// @(#)PatientGui.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class PatientGui {
    
    final JLabel frameLabel 
	= new JLabel("Welcome to the 'Patient'  window. Please choose a"+
		   " function!");
    public JFrame patientFrame;
    JPanel patientPanel;
    GridBagLayout patientGridbag;
    GridBagConstraints gridBagConstraints;
    GridBagConstraints patientsConstraints;

    public JButton addButton;
    public JButton displayButton;
    public JButton deleteButton;
    public JButton changeButton;
    final Insets buttonSize = new Insets(25, 25, 25, 25);
    
    public JButton exitWindowButton;
    public JButton resetWindowButton;
    public JButton okButton;
    
    JLabel nameLabel;
    JLabel fnrLabel;
    JLabel addressLabel;
    JLabel phoneLabel;
    JLabel statusLabel;
    JLabel infoLabel;
    JLabel fnrInfoLabel;

    JTextField nameTextField;
    JTextField fnrTextField;
    JTextField addressTextField;
    JTextField phoneTextField;
    JTextField statusTextField;

    //bottom stuff
    GridBagLayout bottomGridBag;
    GridBagConstraints bottomConstraints;
    JPanel bottomButtonsPanel;
    
    Rectangle bounds;
    //constructor
    public PatientGui(){
    }
    
    public void createPatientGui(){
	frameLabel.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
	patientFrame = new JFrame("Patient");
	bounds = new Rectangle();
	GraphicsEnvironment ge = GraphicsEnvironment.
	    getLocalGraphicsEnvironment();
	GraphicsDevice gs = ge.getDefaultScreenDevice();
        
	GraphicsConfiguration gc = gs.getDefaultConfiguration();
	patientFrame = new JFrame("Patient", gc);
	bounds = gc.getBounds();
		
	patientGridbag = new GridBagLayout();
	patientPanel = new JPanel(patientGridbag);
	patientsConstraints = new GridBagConstraints();
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 0;
	patientsConstraints.gridwidth = 4;
	patientGridbag.setConstraints(frameLabel, patientsConstraints);
	patientPanel.add(frameLabel);
	createTopButtons();
	createFields();
	createBottomButtons();
	
	// Add JPanel to the JFrame
	patientFrame.getContentPane().add(this.patientPanel);

	patientFrame.setResizable(false);
	patientFrame.pack();
	patientFrame.setLocation(700 + bounds.x, 600 + bounds.y);
	patientFrame.show();
	patientFrame.setVisible(true);
	patientFrame.repaint(1);
    }//createPatientGui

    //creates top buttons and add them to the window
    void createTopButtons(){
	addButton = new JButton("Add");
	changeButton = new JButton("Change");
	deleteButton = new JButton("Delete");
	displayButton = new JButton("Display");
	JPanel topButtonsPanel = new JPanel();
	// setBorder on JPanel
	topButtonsPanel.setBorder(
	    BorderFactory.createCompoundBorder(
		   		BorderFactory.createCompoundBorder(
		      BorderFactory.createTitledBorder("Choose between!"), 
		      BorderFactory.createEmptyBorder(5,5,5,5)),
				topButtonsPanel.getBorder()));
	
	//setBorder
	addButton.setMargin(buttonSize);
	changeButton.setMargin(buttonSize);
	deleteButton.setMargin(buttonSize);
	displayButton.setMargin(buttonSize);
	//add buttons
	topButtonsPanel.add(addButton);
	topButtonsPanel.add(changeButton);
	topButtonsPanel.add(deleteButton);
	topButtonsPanel.add(displayButton);
	
	patientsConstraints.gridx = 0;
	patientsConstraints.gridy = 1;
	patientsConstraints.gridwidth = 4;
	patientGridbag.setConstraints(topButtonsPanel, 
			       patientsConstraints);
	patientPanel.add(topButtonsPanel);
    }//createTOpButtons
    
    //create fields but do NOT add them on
    void createFields(){
	infoLabel = new JLabel("");
	infoLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 2;
	patientsConstraints.gridwidth = 4;
	patientGridbag.setConstraints(infoLabel, patientsConstraints);

	nameLabel = new JLabel("Name:       ");
	nameLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 3;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(nameLabel, patientsConstraints);
	
	nameTextField = new JTextField(15);
	nameTextField.setEditable(false);
	patientsConstraints.gridx = 1;
       	patientsConstraints.gridy = 3;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(nameTextField, 
				       patientsConstraints);
	
	fnrLabel = new JLabel("Birth number:");
	fnrLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 4;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(fnrLabel, patientsConstraints);

	fnrInfoLabel = new JLabel("");
	fnrLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	patientsConstraints.gridx = 3;
       	patientsConstraints.gridy = 4;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(fnrInfoLabel, patientsConstraints);
	
	fnrTextField = new JTextField(15);
	fnrTextField.setEditable(false);
	patientsConstraints.gridx = 1;
       	patientsConstraints.gridy = 4;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(fnrTextField, 
				       patientsConstraints);
	
	addressLabel = new JLabel("Address:      ");
	addressLabel.setBorder(BorderFactory.
			      createEmptyBorder(10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 5;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(addressLabel, 
				       patientsConstraints);
	
	addressTextField = new JTextField(15);
	addressTextField.setEditable(false);
	patientsConstraints.gridx = 1;
       	patientsConstraints.gridy = 5;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(addressTextField, 
				       patientsConstraints);
	
	phoneLabel = new JLabel("Phone:       ");
	phoneLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 6;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(phoneLabel, 
				       patientsConstraints);
	
	phoneTextField = new JTextField(15);
	phoneTextField.setEditable(false);
	patientsConstraints.gridx = 1;
       	patientsConstraints.gridy = 6;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(phoneTextField, 
				       patientsConstraints);
	
	statusLabel = new JLabel("Status:     ");
	statusLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 7;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(statusLabel, 
				       patientsConstraints);
	
	statusTextField = new JTextField(15);
	statusTextField.setEditable(false);
	patientsConstraints.gridx = 1;
       	patientsConstraints.gridy = 7;
	patientsConstraints.gridwidth = 1;
	patientGridbag.setConstraints(statusTextField, 
				       patientsConstraints);

	patientPanel.add(infoLabel);
	patientPanel.add(nameLabel);
  	patientPanel.add(fnrLabel);
  	patientPanel.add(fnrInfoLabel);
	patientPanel.add(addressLabel);
  	patientPanel.add(phoneLabel);
	patientPanel.add(statusLabel);
	patientPanel.add(nameTextField);
	patientPanel.add(fnrTextField);
	patientPanel.add(addressTextField);
	patientPanel.add(phoneTextField);
	patientPanel.add(statusTextField);
	nameTextField.setEditable(false);
	fnrTextField.setEditable(false);
	addressTextField.setEditable(false);
	phoneTextField.setEditable(false);
	statusTextField.setEditable(false);
    }//createFields
    
    //add exitWindow and ok buttons to the window
    public void createBottomButtons(){
	exitWindowButton = new JButton("Exit Window");
	resetWindowButton = new JButton("Reset Window");
	okButton = new JButton("Ok");
	
	bottomGridBag = new GridBagLayout();
	bottomConstraints = new GridBagConstraints();
	bottomButtonsPanel = new JPanel(bottomGridBag);
	
	bottomConstraints.gridx = 2;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(exitWindowButton, bottomConstraints);
    	bottomButtonsPanel.add(exitWindowButton);

	bottomConstraints.gridx = 3;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(resetWindowButton, bottomConstraints);
    	bottomButtonsPanel.add(resetWindowButton);
	
	patientsConstraints.gridx = 0;
       	patientsConstraints.gridy = 8;
	patientsConstraints.gridwidth = 4;
	patientGridbag.setConstraints(bottomButtonsPanel,
				      patientsConstraints);
	patientPanel.add(bottomButtonsPanel);
    }//createBottomButtons
    
    //when user push add button this method is used from class AddPatient
    public void addAction(){
	infoLabel.setText("Fill in all fields and press the 'Ok' "+
			  "button");
	fnrInfoLabel.setText("Birth number must be eleven digits");
	nameTextField.setEditable(true);
	fnrTextField.setEditable(true);
	addressTextField.setEditable(true);
	phoneTextField.setEditable(true);
	statusTextField.setEditable(true);
	bottomConstraints.gridx = 1;
       	bottomConstraints.gridy = 0;
	bottomGridBag.setConstraints(okButton, 
				     bottomConstraints);
    	bottomButtonsPanel.add(okButton);
	patientFrame.pack();
	patientFrame.repaint(1);
	patientFrame.setLocation(700 + bounds.x, 600 + bounds.y);
    }//addPatient
    
    //returns a String[] with the information in the 
    //PatientGuis window.
    public String[] getInfo(){
	String[] list = new String[5];
	list[0] = nameTextField.getText();
	list[1] = fnrTextField.getText();
	list[2] = addressTextField.getText();
	list[3] = phoneTextField.getText();
	list[4] = statusTextField.getText();
	return list;
    }//getInfo

    //set window to default
    public void setDefaultWindow(String s){
	nameTextField.setEditable(false);
	fnrTextField.setEditable(false);
	addressTextField.setEditable(false);
	phoneTextField.setEditable(false);
	statusTextField.setEditable(false);
	patientFrame.setResizable(false);
	infoLabel.setText(s);
	fnrInfoLabel.setText("");
	nameTextField.setText("");
	fnrTextField.setText("");
	addressTextField.setText("");
	phoneTextField.setText("");
	statusTextField.setText("");
	bottomButtonsPanel.remove(okButton);
	patientFrame.pack();
	patientFrame.repaint(1);
	patientFrame.setLocation(700 + bounds.x, 600 + bounds.y);
    }//setDefaultWindow

    public void usePatient(String[] list, String s){
	boolean use = false;
	if(s.equals("Change")){
	    use = true;
	    fnrInfoLabel.setText("Birth number must be eleven digits");
	    infoLabel.setText("Change information on patient '"+
			      list[0]+"'" +
			      "and press ok!");
	    bottomConstraints.gridx = 1;
	    bottomConstraints.gridy = 0;
	    bottomGridBag.setConstraints(okButton, 
					 bottomConstraints);
	    bottomButtonsPanel.add(okButton);
	    patientFrame.repaint(1);
	}else{
	    infoLabel.setText("Displaying patient '"+list[0]+"'");
	    patientFrame.repaint(1);
	}//else
	
	nameTextField.setEditable(use);
	fnrTextField.setEditable(use);
	addressTextField.setEditable(use);
	phoneTextField.setEditable(use);
	statusTextField.setEditable(use);;
	nameTextField.setText(list[0]);
	fnrTextField.setText(list[1]);
	addressTextField.setText(list[2]);
	phoneTextField.setText(list[3]);
	statusTextField.setText(list[4]);
	patientFrame.pack();
	patientFrame.repaint(1);
	patientFrame.setLocation(700 + bounds.x, 600 + bounds.y);
    }//usePatient
    
//gets and sets the changes done
    public String[] getChanges(String[] list){
	int a = 0;
	int b = 0;
	int c = 0;
	int d = 0;
	int e = 0;
	String[] changeList = list;
	
	if(fnrTextField.getText().length() != 11){
	    setInfoLabel("Birth number must be eleven digits!");
	}else{
	    if(list[0].equals(nameTextField.getText())){
		a = 0;
	    } else{
		changeList[0] = nameTextField.getText();
		a = 1;
	    }
	    if(list[1].equals(fnrTextField.getText())){
		b = 0;
	    } else{
		b = 1;
		changeList[1] = fnrTextField.getText();
	    }
	    if(list[2].equals(addressTextField.getText())){
		c = 0;
	    } else{
		c = 1;
		changeList[2] = addressTextField.getText();
	    }
	    if(list[3].equals(phoneTextField.getText())){
		d = 0;
	    } else{
	    d = 1;
	    changeList[3] = phoneTextField.getText();
	    }
	    if(list[4].equals(statusTextField.getText())){
		e = 0;
	    } else{
		e = 1;
	    changeList[4] = statusTextField.getText();
	    }
	    
	    if((a == 0) && (b == 0) && (c == 0) && (d == 0) && (e == 0)){
		setInfoLabel("No change made to the choosen patient!");
	    }else{
		setDefaultWindow("Change information has been performed!");
		return changeList;
	    }//else
	}//else
	changeList = null;
	return changeList;
    }//getChanges

    public void setInfoLabel(String s){
	infoLabel.setText(s);
	patientFrame.pack();
	patientFrame.repaint(1);
	patientFrame.setLocation(700 + bounds.x, 600 + bounds.y);
    }//setInfoLabel
    
    public void disposePatientGui(){
	patientFrame.dispose();
    }//disposePatientGui
}//PatientGui
