// @(#)PatientSearch.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.lang.reflect.*;
import java.util.*;
import control.*;

public class PatientSearch{
    
    //builds up the windows for patientResources
    public JFrame patientFrame;
    JPanel patientPanel;
    GridBagLayout patientGrid;
    GridBagConstraints patientConstraint;
    public JButton okButton;
    public JButton cancelButton;
    JLabel patientLabel;
    public JComboBox patientCombo;
    public JLabel foo1Label;
    public JLabel foo2Label;
    public JLabel foo3Label;
    Dimension sizeCombo;
    JLabel infoLabel = new JLabel(" ");
    Rectangle bounds;
    
    public PatientSearch(){
    }
        
    public void createSearchGui(String [] list){
	 bounds = new Rectangle();
	 GraphicsEnvironment ge = GraphicsEnvironment.
	     getLocalGraphicsEnvironment();
	 GraphicsDevice gs = ge.getDefaultScreenDevice();
	 GraphicsConfiguration gc = gs.getDefaultConfiguration();
	 patientFrame = new JFrame("Choose patient!", gc);
	 bounds = gc.getBounds();
	 patientPanel = new JPanel();
	 patientGrid = new GridBagLayout();
	 patientConstraint = new GridBagConstraints();
	 okButton = new JButton("OK");
	 cancelButton = new JButton("Cancel"); 
	 patientPanel.setLayout(patientGrid);
	 patientCombo = new JComboBox(list);
	 patientLabel = new JLabel("Choose a patient");
	 sizeCombo = new Dimension(120, 45);
	 createDropDownList();
	 createLabel();
	 
	 //infoLabel
	 patientConstraint.gridx = 0;
	 patientConstraint.gridy = 3;
	 patientConstraint.gridwidth = 2;
	 infoLabel.setBorder(BorderFactory.createEmptyBorder
			     (10,10,10,10));
	 patientGrid.setConstraints(infoLabel, patientConstraint);
	 patientPanel.add(infoLabel);

	 patientConstraint.gridx = 0;
	 patientConstraint.gridy = 4;
	 patientGrid.setConstraints(okButton, patientConstraint);
	 patientPanel.add(okButton);

	 patientConstraint.gridx = 1;
	 patientConstraint.gridy = 4;
	 patientGrid.setConstraints(cancelButton, patientConstraint);
	 patientPanel.add(cancelButton);
	 
	 patientFrame.getContentPane().add(patientPanel);
	 patientFrame.pack();
	 patientFrame.setLocation(750 + bounds.x, 650 + bounds.y);
	 patientFrame.show();
	 patientFrame.setVisible(true);
	 patientFrame.setResizable(false);
     }// createSearchGui 

    //Paint or rePaint the window
    public void rePaint(){
	patientFrame.pack();
	patientFrame.repaint(1);
	patientFrame.setLocation(750 + bounds.x, 650 + bounds.y);
    }//rePaint

    //add default blank labels to the window
    public void createLabel(){
	foo1Label = new JLabel("");
	foo2Label = new JLabel("");
	//label foo1
	foo1Label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
  	patientConstraint.gridx = 0;
  	patientConstraint.gridy = 1;
  	patientGrid.setConstraints(foo1Label, patientConstraint);
  	patientPanel.add(foo1Label);
	//label foo2
	foo2Label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	patientConstraint.gridx = 0;
	patientConstraint.gridy = 2;
	patientGrid.setConstraints(foo2Label, patientConstraint);
	patientPanel.add(foo2Label);
    }//createLabel

    //create drop down list
    public void createDropDownList(){
	//borders
	patientCombo.setBorder(BorderFactory.createEmptyBorder
				(10,10,20,10));
	patientLabel.setBorder(BorderFactory.createEmptyBorder
				(10,10,20,10));
	//label
	patientConstraint.gridx = 0;
	patientConstraint.gridy = 0;
	patientConstraint.gridwidth = 1;
	patientGrid.setConstraints(patientLabel, 
				       patientConstraint);
	patientPanel.add(patientLabel);
	//combo
	patientConstraint.gridx = 1;
	patientConstraint.gridy = 0;
	patientConstraint.gridwidth = 1;
	patientGrid.setConstraints(patientCombo, 
				       patientConstraint);
	patientPanel.add(patientCombo);
    }//createDropDownList

    public void setInfoLabel(String s){
	infoLabel.setText(s);
    }//setInfoLabel
    
    public void disposePatientSearch(){
	patientFrame.dispose();
    }//disposePatientSearch
}//class searchGui
