// @(#)ResourcesGui.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import control.*;


public class ResourcesGui {
    public JFrame resourceFrame;
    JPanel resourcePanel;
    final Insets buttonSize = new Insets(25, 25, 25, 25);
    public JButton bedButton;
    public JButton roomButton;
    public JButton wardButton;

    public JPanel bottomButtonsPanel;
    public JButton exitWindowResourceButton;
    public JButton resetWindowButton;
    public JButton okResourceButton;
    public JButton addButton;
    public JButton changeButton;
    final JLabel frameLabel = 
	new JLabel("Welcome to the 'Resources' window. Please choose an "+
		   "resource to work on!");
    GridBagLayout resourceGridbag;
    GridBagConstraints resourcesConstraints;
    GridBagLayout bottomGridbag;
    GridBagConstraints bottomConstraints;
    
    // swing stuff to make up default fields
    JLabel infoLabel;
    JLabel numberLabel;
    JLabel nameLabel;
    JLabel typeLabel;
    JLabel availableLabel;
    JLabel roomLabel;
    JLabel wardLabel;
    JLabel typeInfoLabel;
    JLabel possibleTypeLabel; 
    JTextField numberTextField;
    JTextField nameTextField;
    JTextField typeTextField;
    JTextField availableTextField;
    
    
    //keep track of the choice and function
    public String choice;
    String action;
    String function;
    public String wardString;
    String roomString;
    String[] fieldArray;
    
    Rectangle bounds;
    
   
    public HssMain mainWindow;
    MainHandler mainHandler;

    ResourcesGui window;
    // constructor
    public ResourcesGui(){
	window = this;
	
    }//constructor

    //add buttons to the window

    //builds up the Resources window
    public void createResourcesGui(){
	//sets pointer to RegisterHandler
		
	frameLabel.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
		
	bounds = new Rectangle();
	GraphicsEnvironment ge = GraphicsEnvironment.
	    getLocalGraphicsEnvironment();
	GraphicsDevice gs = ge.getDefaultScreenDevice();
	GraphicsConfiguration gc = gs.getDefaultConfiguration();
	resourceFrame = new JFrame("Resources", gc);
	bounds = gc.getBounds();
		
	resourceGridbag = new GridBagLayout();
	resourcePanel = new JPanel(resourceGridbag);
	
	// makes the constraint that places the label
	resourcesConstraints = new GridBagConstraints();
	
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 0;
	resourcesConstraints.gridwidth = 4;
	resourceGridbag.setConstraints(frameLabel, resourcesConstraints);
		
	//methods that build up part of the GUI
	resourcePanel.add(frameLabel);
	createTopButtons();

	//default labels and TextFields
	createFields();
		
	// create bottom buttons
	createBottomButtons();
	
		
	// Add JPanel to the JFrame
	resourceFrame.getContentPane().add(this.resourcePanel);
	
	resourceFrame.setResizable(false);
  	resourceFrame.pack();
	resourceFrame.setLocation(700 + bounds.x, 150 + bounds.y);
	resourceFrame.show();
  	resourceFrame.setVisible(true);
    }//createResourcesGui

    //create fields to display info on
    public void createFields(){
	infoLabel = new JLabel(" ");
	infoLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 2;
	resourcesConstraints.gridwidth = 4;
	resourceGridbag.setConstraints(infoLabel, resourcesConstraints);

	numberLabel = new JLabel("Number:            ");
	numberLabel.setBorder(BorderFactory.createEmptyBorder
			      (10,10,10,10));
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 3;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(numberLabel, resourcesConstraints);
	
	numberTextField = new JTextField(15);
	numberTextField.setEditable(false);
	resourcesConstraints.gridx = 1;
       	resourcesConstraints.gridy = 3;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(numberTextField, 
				       resourcesConstraints);
	
	nameLabel = new JLabel("Name:            ");
	nameLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 4;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(nameLabel, resourcesConstraints);
	
	nameTextField = new JTextField(15);
	nameTextField.setEditable(false);
	resourcesConstraints.gridx = 1;
       	resourcesConstraints.gridy = 4;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(nameTextField, 
				       resourcesConstraints);
	
	typeLabel = new JLabel("Type:           ");
	typeLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 5;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(typeLabel, 
				       resourcesConstraints);
	
	typeTextField = new JTextField(15);
	typeTextField.setEditable(false);
	resourcesConstraints.gridx = 1;
       	resourcesConstraints.gridy = 5;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(typeTextField, 
				       resourcesConstraints);
	
	availableLabel = new JLabel("Available:           ");
	availableLabel.setBorder(BorderFactory.createEmptyBorder
				 (10,10,10,10));
	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 6;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(availableLabel, 
				       resourcesConstraints);
	
	availableTextField = new JTextField(15);
	availableTextField.setEditable(false);
	resourcesConstraints.gridx = 1;
       	resourcesConstraints.gridy = 6;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(availableTextField, 
				       resourcesConstraints);
	
	wardLabel = new JLabel("");
	wardLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 3;
       	resourcesConstraints.gridy = 3;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(wardLabel, 
				       resourcesConstraints);

	roomLabel = new JLabel("");
	roomLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 3;
       	resourcesConstraints.gridy = 4;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(roomLabel, 
				       resourcesConstraints);

	typeInfoLabel = new JLabel(" ");
	typeInfoLabel.setBorder
	    (BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 3;
       	resourcesConstraints.gridy = 5;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(typeInfoLabel, 
				       resourcesConstraints);

	possibleTypeLabel = new JLabel(" ");
	possibleTypeLabel.setBorder
	    (BorderFactory.createEmptyBorder(10,10,10,10));
	resourcesConstraints.gridx = 3;
       	resourcesConstraints.gridy = 6;
	resourcesConstraints.gridwidth = 1;
	resourceGridbag.setConstraints(possibleTypeLabel, 
				       resourcesConstraints);

	//adds stuff to panel
	resourcePanel.add(typeInfoLabel);
	resourcePanel.add(possibleTypeLabel);
	resourcePanel.add(roomLabel);
	resourcePanel.add(wardLabel);
	resourcePanel.add(infoLabel);
	resourcePanel.add(numberLabel);
	resourcePanel.add(numberTextField);
	resourcePanel.add(nameLabel);
	resourcePanel.add(nameTextField);
	resourcePanel.add(typeLabel);
	resourcePanel.add(typeTextField);	
	resourcePanel.add(availableLabel);
	resourcePanel.add(availableTextField);	
    }//createFields

    
    //adds top row of buttons to the window
    public void createTopButtons(){
	bedButton = new JButton("Bed");
	roomButton = new JButton("Room");
	wardButton = new JButton("Ward");
	JPanel topButtonsPanel = new JPanel(new FlowLayout
	    (FlowLayout.CENTER,	35,0));

	// setBorder on JPanel
	topButtonsPanel.setBorder(
	    BorderFactory.createCompoundBorder(
		   		BorderFactory.createCompoundBorder(
		      BorderFactory.createTitledBorder("Choose between!"), 
		      BorderFactory.createEmptyBorder(5,5,5,5)),
				topButtonsPanel.getBorder()));
	
	//setBorder
	bedButton.setMargin(buttonSize);
	roomButton.setMargin(buttonSize);
	wardButton.setMargin(buttonSize);
	//add buttons
	topButtonsPanel.add(bedButton);
	topButtonsPanel.add(roomButton);
	topButtonsPanel.add(wardButton);
	
	resourcesConstraints.gridx = 0;
	resourcesConstraints.gridy = 1;
	resourcesConstraints.gridwidth = 4;
	resourceGridbag.setConstraints(topButtonsPanel, 
			       resourcesConstraints);
	resourcePanel.add(topButtonsPanel);
    }//createButtons
    
    //create and adds the bottom row of buttons
    public void createBottomButtons(){
	exitWindowResourceButton = new JButton("Exit Window");
	resetWindowButton = new JButton("Reset Window");
	
	bottomGridbag = new GridBagLayout();
	bottomConstraints = new GridBagConstraints();
	bottomButtonsPanel = new JPanel(bottomGridbag);
	
	bottomConstraints.gridx = 2;
       	bottomConstraints.gridy = 0;
	bottomGridbag.setConstraints(exitWindowResourceButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(exitWindowResourceButton);

	bottomConstraints.gridx = 3;
       	bottomConstraints.gridy = 0;
	bottomGridbag.setConstraints(resetWindowButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(resetWindowButton);

	resourcesConstraints.gridx = 0;
       	resourcesConstraints.gridy = 7;
	resourcesConstraints.gridwidth = 4;
	resourceGridbag.setConstraints(bottomButtonsPanel, 
				       resourcesConstraints);
	resourcePanel.add(bottomButtonsPanel);
    }//createBottomButtons
    
    public void createAddButton(){
	addButton = new JButton("Add");
	bottomConstraints.gridx = 1;
       	bottomConstraints.gridy = 0;
	bottomGridbag.setConstraints(addButton, 
				       bottomConstraints);
	bottomButtonsPanel.add(addButton);
	resourceFrame.pack();
	resourceFrame.repaint(1);
	resourceFrame.setLocation(700 + bounds.x, 150 + bounds.y);
    }//createAddButton
    
    //adds change button when invoked from ModifyResources
    public void addChangeButton(){
	changeButton = new JButton("Change");
	bottomConstraints.gridx = 1;
       	bottomConstraints.gridy = 0;
	bottomGridbag.setConstraints(changeButton, 
				     bottomConstraints);
	bottomButtonsPanel.add(changeButton);
	resourceFrame.pack();
	resourceFrame.repaint(1);
	resourceFrame.setLocation(700 + bounds.x, 150 + bounds.y);
    }//addChangeButton
    
    //add a Beds Info to the window
    public void addBedInfo(String[] s){
	getFunctionName(s);
	addInfoToField();	
	availableLabel.setText(choice + " available?       ");
	availableTextField.setText("");
	typeInfoLabel.setText("");
	roomLabel.setText("Room: " +s[2]);
	wardLabel.setText("Ward: " +s[1]);
	typeTextField.setText(s[4]);
	typeTextField.setEditable(false);
	roomString = s[2];
	resourceFrame.repaint(1);
    }//addBedInfo
    
    //add a Rooms window to the window
    public void addRoomInfo(String[] s){
	getFunctionName(s);
	addInfoToField();
	availableLabel.setText(choice + " available?       ");
	availableTextField.setText("");
	wardLabel.setText("Ward: " +s[1]);
	typeTextField.setText("");
	wardString = s[1];
	roomLabel.setText("");
	resourceFrame.repaint(1);
    }//addRoomInfo
    
    //add a Wards window to the window
    public void addWardInfo(String[] s){
	getFunctionName(s);
	addInfoToField();
	availableLabel.setText(" ");
	availableTextField.setText("");
	roomLabel.setText("");
	wardLabel.setText("");
	resourceFrame.repaint(1);
    }//addWardInfo
    
    // gets the function from the string[] and sets the action string
    public void getFunctionName(String[] s){
	action = s[0];
	StringTokenizer t = new StringTokenizer(action);
	function = t.nextToken();
    }//getFunctionName
    
    //set stuff that is common for room, ward and bed
    public void addInfoToField(){
	if(function.equals("Add") != function.equals("Change")){
	    setLayoutField();
	    infoLabel.setText("Fill in and press " + 
			      "the 'Ok' button to fulfill the '"+ 
			      action + "' function."); 
	}//if
	else
	    {
		infoLabel.setText(" Function " + "'"+ action +"'"  + 
				  " is performed" +
				  " on the following information");
	    }//else
	numberLabel.setText(choice+" number       ");
	numberTextField.setText("");
	if((!choice.equals("Room")) || (!choice.equals("Room"))){
	nameLabel.setText(choice + " name           ");
	}
	nameTextField.setText("");
	typeLabel.setText(choice + " type            ");
    }//addInfoToField
   
    // sets layout for add and change function
    public void setLayoutField(){
	numberTextField.setEditable(true);
	nameTextField.setEditable(true);
	typeTextField.setEditable(true);
	if(!choice.equals("Ward")){
	availableTextField.setEditable(true);
	nameTextField.setEditable(false);
	nameLabel.setText("");
	}//if
    }//setLayoutField

     public void setDefaultResourceWindow(String s){
	numberLabel.setText("Number:            ");
	nameLabel.setText("Name:            ");
	typeLabel.setText("Type:            ");
	availableLabel.setText("Available:            ");
	numberTextField.setText("");
	nameTextField.setText("");
	typeTextField.setText("");
	availableTextField.setText("");
	typeInfoLabel.setText("");
	possibleTypeLabel.setText("");
	numberTextField.setEditable(false);
	nameTextField.setEditable(false);
	typeTextField.setEditable(false);
	availableTextField.setEditable(false);
	if(addButton != null){
	    bottomButtonsPanel.remove(addButton);
	    addButton = null;
	    resourceFrame.pack();
	    resourceFrame.repaint(1);
	    resourceFrame.setLocation(700 + bounds.x, 150 + bounds.y);
	}
	if(changeButton != null){
	    bottomButtonsPanel.remove(changeButton);
	    changeButton = null;
	    resourceFrame.pack();
	    resourceFrame.repaint(1);
	    resourceFrame.setLocation(700 + bounds.x, 150 + bounds.y);
	}
  	infoLabel.setText(s);
  	wardLabel.setText("");
  	roomLabel.setText("");
	resourceFrame.repaint(1);
     }//setDefaultResourceWindow
    
    //puts info in the window
    public void displayInfo(String number, String name, String type, 
			    String available){
	numberTextField.setText(number);
	if(choice.equals("Bed")){
	    nameLabel.setText("");
	    typeTextField.setEditable(false);
	}
	
	if(choice.equals("Room")){
	    nameLabel.setText("");
	    roomLabel.setText("");
	}
	if(choice.equals("Ward")){
	 availableLabel.setText("");
	 wardLabel.setText("");
	 roomLabel.setText("");
	}
	nameTextField.setText(name);
	typeTextField.setText(type);
	availableTextField.setText(available);
	resourceFrame.repaint(1);

    }//displayInfo

    public void setTypeInfo(){
	typeInfoLabel.setText("Type must be either:");
	possibleTypeLabel.setText("'Operation', 'Recovery' or 'Waiting'");
	resourceFrame.repaint(1);
    }//setTypeInfo
    
    public void setInfoLabel(String s){
	infoLabel.setText(s);
	resourceFrame.repaint(1);
    }//setInfoLabel

    public void disposeResourcesGui(){
	resourceFrame.dispose();
    }//disposeResourcesGui
    
    //sets the fieldArray
    public String[] setStringArray(){
	String s;
	String[] fieldArray = new String[10];
	fieldArray[0] = choice;
	s = choice;
	fieldArray[1] = numberTextField.getText();
	fieldArray[2] = nameTextField.getText();
	if((s.equals("Bed")) || (s.equals("Room"))){
	    fieldArray[2] = " ";
	}//if
	fieldArray[3] = typeTextField.getText();
	fieldArray[4] = availableTextField.getText();
	fieldArray[5] = wardString;
	if(roomString != null){
	   fieldArray[6] = roomString;
	}//if
	return fieldArray;
    }//setStringArray
    
    public void setWardLabel(String s){
	wardLabel.setText(s);
	resourceFrame.repaint(1);
    }//setWardLabel

    public void setRoomLabel(String s){
	roomLabel.setText(s);
	resourceFrame.repaint(1);
    }//setRoomLabel
    
    //gets and sets the changes done
    public String[] getChanges(String[] changeList){
	int a = 0;
	int b = 0;
	int c = 0;
	int d = 0;
	String[] list = changeList;
	if(changeList[0].equals(numberTextField.getText())){
	    a = 0;
	} else{
	    list[0] = numberTextField.getText();
	    a = 1;
	}
	if(choice.equals("Ward")){
	    if(changeList[1].equals(nameTextField.getText())){
		b = 0;
	    } else{
		b = 1;
		list[1] = nameTextField.getText();
	    }
	}
	if(changeList[2].equals(typeTextField.getText())){
	    c = 0;
	} else{
	    c = 1;
	    list[2] = typeTextField.getText();
	}
	if(changeList[3].equals(availableTextField.getText())){
	    d = 0;
	} else{
	    d = 1;
	    list[3] = availableTextField.getText();
	}
	
	if(choice.equals("Ward")){
	    if((a == 0) && (b == 0) && (c == 0) && (d == 0)){
		setInfoLabel("No change made to the choosen resource!");
		return null;
	    }else{
		if(choice.equals("Ward")){
		    setDefaultResourceWindow
			("Change information has been performed!");
		    return list;
		}
		if(changeButton != null){
		    bottomButtonsPanel.remove(changeButton);
		}
	    }//else
	}//if
	
	if((choice.equals("Bed")) ||
	   (choice.equals("Room"))){
	    if((a == 0) && (c == 0) && (d == 0)){
		setInfoLabel("No change made to the choosen resource!");
		return null;
	    }else{
		if(choice.equals("Room")){
		    setDefaultResourceWindow
			("Change information has been performed!");
		    return list;
		}
		if(choice.equals("Bed")){
		    setDefaultResourceWindow
			("Change information has been performed!");
		    return list;
		}
	    }//else
	    setDefaultResourceWindow("");
	    if(changeButton != null){
		bottomButtonsPanel.remove(changeButton);
	    }
	}//if
	return list;
    }//getChanges
}//class    














