// @(#)SearchWindowGui.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch

package gui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.lang.*;
import java.lang.reflect.*;
import java.util.*;
import control.*;

public class SearchWindowGui{
    
    //builds up the windows for chooseResources
    public JFrame chooseFrame;
    JPanel choosePanel;
    GridBagLayout chooseGrid;
    GridBagConstraints chooseConstraint;
    
    public JButton okChooseButton;
    public JButton cancelChooseButton;
    public JButton okBeforeButton;
    public JButton cancelBeforeButton;
    JLabel functionLabel;
    public JComboBox functionCombo;
    public JComboBox wardCombo;
    public JLabel wardLabel;
    public JComboBox roomCombo;
    public JLabel roomLabel;
    public JComboBox bedCombo;
    public JLabel bedLabel;
    Dimension sizeCombo;
    public JLabel infoLabel = new JLabel(" ");
    
    //Strings that remembers what to choose
    String[] parameterString = new String[10];
    public String defaultString;
    public String wardChoice;
    public String roomChoice;
    public String bedChoice;

    // Link back to the mother window
    ResourcesGui motherWindow;
    // Link to control object
    HandleResource handleResource;
    SearchWindowGui searchWindowGui;
    Rectangle bounds;

   public SearchWindowGui(String s){
	init(s);
    }
    
    private void init(String s){
	defaultString = s;
    }
    
    public void createSearchGui(){
	 bounds = new Rectangle();
	 GraphicsEnvironment ge = GraphicsEnvironment.
	     getLocalGraphicsEnvironment();
	 GraphicsDevice gs = ge.getDefaultScreenDevice();
	 
	 GraphicsConfiguration gc = gs.getDefaultConfiguration();
	 chooseFrame = new JFrame("Choose resource!", gc);
	 bounds = gc.getBounds();
	 choosePanel = new JPanel();
	 chooseGrid = new GridBagLayout();
	 chooseConstraint = new GridBagConstraints();
	 okBeforeButton = new JButton("OK");
	 cancelBeforeButton = new JButton("Cancel"); 
	 
	 //remember to set string info with the correct rooms
	 choosePanel.setLayout(chooseGrid);
		
	//adds function label and combobox to the window
	 String[] list = {"Add a "+defaultString, "Change a " +
			  defaultString +" info",
			  "Delete a " +defaultString, "Display " +
			  defaultString +" info"}; 
	 functionCombo = new JComboBox(list);
	 functionLabel = new JLabel("Choose a function");
	 sizeCombo = new Dimension(120, 45);
	 
	 createDropDownList();
	 createLabel();
	 
	 //infoLabel
	 chooseConstraint.gridx = 0;
	 chooseConstraint.gridy = 4;
	 chooseConstraint.gridwidth = 2;
	 infoLabel.setBorder(BorderFactory.createEmptyBorder
			     (10,10,10,10));
	 chooseGrid.setConstraints(infoLabel, chooseConstraint);
	 choosePanel.add(infoLabel);
	 
	 //ok button
	 chooseConstraint.gridx = 0;
	 chooseConstraint.gridy = 5;
	 chooseGrid.setConstraints(okBeforeButton, chooseConstraint);
	 choosePanel.add(okBeforeButton);
	 //cancel button
	 chooseConstraint.gridx = 1;
	 chooseConstraint.gridy = 5;
	 chooseGrid.setConstraints(cancelBeforeButton, chooseConstraint);
	 choosePanel.add(cancelBeforeButton);
	 
	 //frame
	 chooseFrame.getContentPane().add(choosePanel);
	 chooseFrame.pack();
	 chooseFrame.setLocation(750 + bounds.x, 150 + bounds.y);
	 chooseFrame.show();
	 chooseFrame.setVisible(true);
	 chooseFrame.setResizable(false);
	 chooseFrame.repaint(1);
     }// createSearchGui 

    public void removeOkCancelButton(){
	if(okChooseButton != null){
	choosePanel.remove(okChooseButton);
	}
	if(cancelChooseButton != null){
	choosePanel.remove(cancelChooseButton);
	}
    }//removeOkCancelButton
    
    //adds the real button for add and modify control objects
    public void okCancelButton(){
	choosePanel.remove(okBeforeButton);
	choosePanel.remove(cancelBeforeButton);
	okChooseButton = new JButton("OK");
	cancelChooseButton = new JButton("Cancel"); 
	//ok button
	chooseConstraint.gridx = 0;
	chooseConstraint.gridy = 5;
	chooseGrid.setConstraints(okChooseButton, chooseConstraint);
	choosePanel.add(okChooseButton);
	//cancel button
	chooseConstraint.gridx = 1;
	chooseConstraint.gridy = 5;
	chooseGrid.setConstraints(cancelChooseButton, chooseConstraint);
	choosePanel.add(cancelChooseButton);
    }//okCancelButton

    //Paint or rePaint the window
    public void rePaint(){
	chooseFrame.pack();
	chooseFrame.setLocation(750 + bounds.x, 150 + bounds.y);
	chooseFrame.repaint(1);
    }//rePaint

    public void setDefaultWindow(String s){
	if(defaultString.equals("Bed")){
	    if(s.equals("There exist no wards!"))
		wardLabel.setText(" ");
	    else
		wardLabel.setText("Choose Ward");
	}//if
	else
	    wardLabel.setText(" ");
	roomLabel.setText(" ");
	bedLabel.setText(" ");
	infoLabel.setText(s);
	if(roomCombo != null)
	    choosePanel.remove(roomCombo);
	rePaint();
    }//setDefaultWindow

    //add default blank labels to the window
    public void createLabel(){
	wardLabel = new JLabel(" ");
	roomLabel = new JLabel(" ");
	bedLabel = new JLabel(" "); 
	
	//label ward
	wardLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
  	chooseConstraint.gridx = 0;
  	chooseConstraint.gridy = 1;
  	chooseGrid.setConstraints(wardLabel, chooseConstraint);
  	choosePanel.add(wardLabel);
	
	//label room
	roomLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	chooseConstraint.gridx = 0;
	chooseConstraint.gridy = 2;
	chooseGrid.setConstraints(roomLabel, chooseConstraint);
	choosePanel.add(roomLabel);
	
	//label bed
	bedLabel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	chooseConstraint.gridx = 0;
	chooseConstraint.gridy = 3;
	chooseGrid.setConstraints(bedLabel, chooseConstraint);
	choosePanel.add(bedLabel);
    }//createLabel

    //Adds ward combo to the window
    public void putWard(String[] s){
	wardCombo = new JComboBox(s);
	wardCombo.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
  	chooseConstraint.gridx = 1;
  	chooseConstraint.gridy = 1;
  	chooseGrid.setConstraints(wardCombo, chooseConstraint);
	wardCombo.setPreferredSize(sizeCombo);
	choosePanel.add(wardCombo);
	rePaint();
    }//putWard

    //inititated from a control object. Adds a combo to the window
    public void putRoom(String[] s){
	roomCombo = new JComboBox(s);
	roomCombo.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	chooseConstraint.gridx = 1;
	chooseConstraint.gridy = 2;
	chooseGrid.setConstraints(roomCombo, chooseConstraint);
	roomCombo.setPreferredSize(sizeCombo);
	roomCombo.setEnabled(true);
	choosePanel.add(roomCombo);
	rePaint();
    }//putRoom

      //inititated from a control object. Adds a combo to the window
    public void putBed(String[] s){
	bedCombo = new JComboBox(s);
	bedCombo.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	chooseConstraint.gridx = 1;
	chooseConstraint.gridy = 3;
	chooseGrid.setConstraints(bedCombo, chooseConstraint);
	bedCombo.setPreferredSize(sizeCombo);
	bedCombo.setEnabled(true);
	choosePanel.add(bedCombo);
	rePaint();
    }//putBed
    
    //create drop down list
    public void createDropDownList(){
	//borders
	functionCombo.setBorder(BorderFactory.createEmptyBorder
				(10,10,10,10));
	functionLabel.setBorder(BorderFactory.createEmptyBorder
				(10,10,10,10));
	//label
	chooseConstraint.gridx = 0;
	chooseConstraint.gridy = 0;
	chooseConstraint.gridwidth = 1;
	chooseGrid.setConstraints(functionLabel, 
				       chooseConstraint);
	choosePanel.add(functionLabel);
	
	//combo
	chooseConstraint.gridx = 1;
	chooseConstraint.gridy = 0;
	chooseConstraint.gridwidth = 1;
	chooseGrid.setConstraints(functionCombo, 
				       chooseConstraint);
	choosePanel.add(functionCombo);
    }//createDropDownList

    //reset window
    public void resetSearchGui(){
	if(wardCombo != null){
	  choosePanel.remove(wardCombo);
	}
	if(wardLabel!= null){
	   wardLabel.setText(" ");
	}
	if(roomCombo != null){
	   choosePanel.remove(roomCombo);
	}
	if(roomLabel!= null){
	    roomLabel.setText(" ");
	}
	if(bedCombo != null){
	   choosePanel.remove(bedCombo);
	}
	if(bedLabel!= null){
	   bedLabel.setText(" ");
	}
	if(infoLabel != null){
	    infoLabel.setText("");
	}
	rePaint();
    }//resetSearchGui
    
    //if user makes another choice of ward AFTER a choice of room 
    //and/or bed have been done. This method clears up.
    public void removeFromBedWard(){
	if(roomCombo != null){
	    choosePanel.remove(roomCombo);
	    setRoomLabel("Room");
	}//if
	if(bedCombo != null){
	    choosePanel.remove(bedCombo);
	    setBedLabel("Bed");
	}
	setInfoLabel("");
    }//removeFromBedWard
    
    //if user makes another choice of room AFTER a choice of room 
    //and/or bed have been done. This method clears up.
    public void removeFromBedRoom(){
	if(bedCombo != null){
	    choosePanel.remove(bedCombo);
	    setBedLabel("Bed");
	    setInfoLabel("");
	}
    }//removeFromBedRoom
    
    public void clearWindow(){
	if(wardCombo != null)
	    choosePanel.remove(wardCombo);
	if(roomCombo != null)
	    choosePanel.remove(roomCombo);
	if(bedCombo != null)
	choosePanel.remove(bedCombo);
    }//clearWindow

    public void disposeSearchWindowGui(){
	chooseFrame.dispose();
    }//disposeSearchWindowGui
    
    public void setInfoLabel(String s){
	infoLabel.setText(s);
	chooseFrame.pack();
	chooseFrame.setLocation(750 + bounds.x, 150 + bounds.y);
	chooseFrame.repaint(1);
    }//setInfoLabel
    
    public void setWardLabel(String s){
	wardLabel.setText(s);
	chooseFrame.repaint(1);
    }//setWardLabel

    public void setRoomLabel(String s){
	roomLabel.setText(s);
	chooseFrame.repaint(1);
    }//setRoomLabel

    public void setBedLabel(String s){
	bedLabel.setText(s);
	chooseFrame.repaint(1);
    }//setBedLabel
}//class search
