// @(#)EmployeeRegister.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


//
// File          : EmployeeRegister.java
//
// Project       : IN219
// Configuration : Leveranse4 1
// Phase         : Implementation 1
// System        : Klasse 1
//
package model;

import java.util.Vector;
import java.io.*;
// Begin user import section


// End user import section

// Do not delete this line -- Start Class Declarations

public class EmployeeRegister  implements Serializable {

    // Data attributes

    public int numberOfEmployee;

    // Association attributes

    private Vector hasEmployeeSet;

    // Default constructor

    public EmployeeRegister() {
        hasEmployeeSet = new Vector();

        // Start user code section
        // End user code section
    }


    // User defined constructors


    // Methods
    
    public boolean addEmployee(String[] s){
	boolean bol = false;
	boolean notFound = false;
	Employee temp;

	for(int i = 0; i < hasEmployeeSet.size();i++){
	    temp = (Employee)hasEmployeeSet.elementAt(i);
	    if(s[1].equals(temp.getFnr())){
		return bol;
	    }//if
	}//for
   
	if(hasEmployeeSet.size() > 0){
	    if(s[6].equals("Doctor")){
		Doctor w = new Doctor(s[0], s[1], s[2], s[3], s[4], s[5]);
		addHasEmployee(w);
		bol = true;
	    }else if(s[6].equals("Nurse")){
		Nurse w = new Nurse(s[0], s[1], s[2], s[3], s[4], s[5]);
		addHasEmployee(w);
		bol = true;
	    }
	}
	
	if(hasEmployeeSet.size() == 0){
	    if(s[6].equals("Doctor")){
		Doctor w = new Doctor(s[0], s[1], s[2], s[3], s[4], s[5]);
		addHasEmployee(w);
		bol = true;
	    }else if(s[6].equals("Nurse")){
		Nurse w = new Nurse(s[0], s[1], s[2], s[3], s[4], s[5]);
		addHasEmployee(w);
		bol = true;
	    }
	}//if
	return bol;
    }//addEmployee
    
     public void deleteEmployee(String s){
	Employee employee;
	for(int i = 0; i < hasEmployeeSet.size();i++){
	    employee = (Employee)hasEmployeeSet.elementAt(i);
	    if(s.equals(employee.getFnr())){
		removeHasEmployee(employee);
	    }
	}//for
    }//deleteEmployee
    
    //return all employees in a String[]
    public String[][] getEmployees(){
	Employee employee;
	String[][] list = new String[hasEmployeeSet.size()][2];
	for(int i = 0; i < hasEmployeeSet.size();i++){
	    employee = (Employee)hasEmployeeSet.elementAt(i);
	    list[i][0] = employee.getName();
	    list[i][1] = employee.getFnr();
	}//for
	return list;
    }//getEmployees


    public String[] getEmployeeInfo(String choice){
	String[] list = new String[8];
	Employee employee;
	for(int i = 0; i < hasEmployeeSet.size();i++){
	    employee = (Employee)hasEmployeeSet.elementAt(i);
	    if(choice.equals(employee.getFnr())){
		if(employee instanceof Doctor){ 
		    Doctor doctor = (Doctor) employee;
		    list[0] = doctor.getName();
		    list[1] = doctor.getFnr();
		    list[2] = doctor.getAddress();
		    list[3] = doctor.getPhone();
		    list[4] = doctor.getPager();
		    list[5] = doctor.getKindOf();
		    list[6] = "Doctor";
		}
		if(employee instanceof Nurse){ 
		    Nurse nurse = (Nurse) employee;
		    list[0] = nurse.getName();
		    list[1] = nurse.getFnr();
		    list[2] = nurse.getAddress();
		    list[3] = nurse.getPhone();
		    list[4] = nurse.getPager();
		    list[5] = nurse.getKindOf();
		    list[6] = "Nurse";
		}
	    }
	}//for
	return list;
    }//getEmployeeInfo

    public void changeEmployee(String[] list){
	Employee employee;
	for(int i = 0; i < hasEmployeeSet.size();i++){
	    employee = (Employee)hasEmployeeSet.elementAt(i);
	    if(list[6].equals(employee.getFnr())){
		if(employee instanceof Doctor){ 
		    Doctor doctor = (Doctor) employee;
		    doctor.setName(list[0]);
		    doctor.setFnr(list[1]);
		    doctor.setAddress(list[2]);
		    doctor.setPhone(list[3]);
		    doctor.setPager(list[4]);
		    doctor.setKindOf(list[5]);
		}
		if(employee instanceof Nurse){ 
		    Nurse nurse = (Nurse) employee;
		    nurse.setName(list[0]);
		    nurse.setFnr(list[1]);
		    nurse.setAddress(list[2]);
		    nurse.setPhone(list[3]);
		    nurse.setPager(list[4]);
		    nurse.setKindOf(list[5]);
		    
		}
	    }
	}//for
    }//changeEmployee

    
    public void locatePersonell(String info, String time, String date) {
    }

    public void compareInfo(String info, String time, String date) {
    }

    public void getOnCall(String type) {
    }

    public void modifyEmployee(String id) {
    }


    // Do not delete this line -- regeneration end marker

    // Attribute accessors

    public int getNumberOfEmployee() {
        return numberOfEmployee;
    }

    public void setNumberOfEmployee(int numberOfEmployee_) {
        numberOfEmployee = numberOfEmployee_;
    }


    // Association accessors

    public void addHasEmployee(Employee hasEmployee_) {
        if (hasEmployee_ == null)
            return;
        hasEmployeeSet.addElement(hasEmployee_);
    }

    public void removeHasEmployee(Employee hasEmployee_) {
        if (hasEmployee_ == null)
            return;
        hasEmployeeSet.removeElement(hasEmployee_);
    }

    public Vector getHasEmployeeSet() {
        return (Vector)hasEmployeeSet.clone();
    }

} // class EmployeeRegister


// Do not delete this line -- End Class Declarations
