// @(#)PatientRegister.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


//
// File          : PatientRegister.java
//
// Project       : IN219
// Configuration : Leveranse4 1
// Phase         : Implementation 1
// System        : Klasse 1
//
package model;

// Begin user import section
import java.util.Vector;
import java.io.*;
// End user import section

// Do not delete this line -- Start Class Declarations

public class PatientRegister implements Serializable{

    // Data attributes

    private int numberOfPatient;

    // Association attributes

    public Vector hasPatientSet;
    
    // Default constructor

    public PatientRegister() {
        hasPatientSet = new Vector();

        // Start user code section
        // End user code section
    }


    // User defined constructors


    // Methods

    public void locatePatient(String fnr) {
    }

    public void checkFnr(String fnr) {
    }

    public void checkOut(String fnr) {
    }

    public void getInfoReport() {
    }

    public void modifyPatient(String fnr) {
    }

    public boolean addPatient(String[] list) {
	boolean temp = false;
	Patient patient;
	for(int i = 0; i < hasPatientSet.size();i++){
	    patient = (Patient)hasPatientSet.elementAt(i);
	    if(list[1].equals(patient.fnr)){
		return temp;
	    }//if
	}//for

	if(hasPatientSet.size() > 0){
	    Patient p = new Patient(list);
	    addHasPatient(p);
	    temp = true;
	}
	
	if(hasPatientSet.size() == 0){
	    Patient p = new Patient(list);
	    addHasPatient(p);
	    temp = true;
	}//if
	return temp;
    }//addPatient

    public void deletePatient(String s){
	Patient patient;
	for(int i = 0; i < hasPatientSet.size();i++){
	    patient = (Patient)hasPatientSet.elementAt(i);
	    if(s.equals(patient.getFnr())){
		removeHasPatient(patient);
	    }
	}//for
    }//deletePatient
    
    public void changePatient(String[] list){
	Patient patient;
	for(int i = 0; i < hasPatientSet.size();i++){
	    patient = (Patient) hasPatientSet.elementAt(i);
	    if(list[5].equals(patient.getFnr())){
		patient.setName(list[0]);
		patient.setFnr(list[1]);
		patient.setAddress(list[2]);
		patient.setPhone(list[3]);
		patient.setStatus(list[4]);
	    }
	}//for
    }//changepatient
    
    //return all patients in a String[]
    public String[][] getPatients(){
	Patient patient;
	String[][] list = new String[hasPatientSet.size()][2];
	for(int i = 0; i < hasPatientSet.size();i++){
	    patient = (Patient)hasPatientSet.elementAt(i);
	    list[i][0] = patient.getName();
	    list[i][1] = patient.getFnr();
	}//for
	return list;
    }//getPatients
    
    public String[] getPatientInfo(String choice){
	String[] list = new String[6];
	Patient patient;
	for(int i = 0; i < hasPatientSet.size();i++){
	    patient = (Patient)hasPatientSet.elementAt(i);
	    if(choice.equals(patient.fnr)){
		list[0] = patient.getName();
		list[1] = patient.getFnr();
		list[2] = patient.getAddress();
		list[3] = patient.getPhone();
		list[4] = patient.getStatus();
	    }
	}//for
	return list;
    }//getPatientInfo
    
    // Do not delete this line -- regeneration end marker

    // Attribute accessors

    public int getNumberOfPatient() {
        return numberOfPatient;
    }

    public void setNumberOfPatient(int numberOfPatient_) {
        numberOfPatient = numberOfPatient_;
    }


    // Association accessors

    
    public void addHasPatient(Patient hasPatient_) {
        if (hasPatient_ == null)
            return;
        hasPatientSet.addElement(hasPatient_);
    }

    public void removeHasPatient(Patient hasPatient_) {
        if (hasPatient_ == null)
            return;
        hasPatientSet.removeElement(hasPatient_);
    }

    public Vector getHasPatientSet() {
        return (Vector)hasPatientSet.clone();
    }

    
} // class PatientRegister


// Do not delete this line -- End Class Declarations
