// @(#)Room.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


//
// File          : Room.java
//
// Project       : IN219
// Configuration : Leveranse4 1
// Phase         : Implementation 1
// System        : Klasse 1
//
package model;

import java.util.Vector;
import java.io.*;
// Begin user import section


// End user import section

// Do not delete this line -- Start Class Declarations

public class Room implements Serializable {

    // Data attributes

    public String number;
    public String type;
    public String available;
    public int numberOfBeds;
    public String equipment[];

    // Association attributes

    protected Ward hasWard;
    protected Vector hasBedSet;
//      protected Vector hasOperationSet;

    // Default constructor

//      public Room(Ward hasWard_) {
//          hasWard = hasWard_;
//          hasBedSet = new Vector();
//          hasOperationSet = new Vector();

//          // Start user code section
//          // End user code section
//      }


    // User defined constructors

    public Room(String number_, String type_, 
		String available_, Ward ward){
	number= number_;
	type = type_;
	available = available_;
	hasWard = ward;
	hasBedSet = new Vector();
    }
    // Methods

    public void modifyRoom(String info) {
    }

    //get data on bed_ and returns String[]
    public String[] displayBed(String bed_){
	Bed bed;
	String[] list = new String[4];
	for(int i = 0; i < hasBedSet.size();i++){
	    bed = (Bed) hasBedSet.elementAt(i);
	    if(bed_.equals(bed.number)){
		list[0] = bed.number;
		list[2] = bed.type;
		list[3] = bed.available;
	    }//if
	}//for
	return list;
    }//displayBed

    //adds a bed to this room 
    public boolean createBed(String[] s){
	Bed bed;
	boolean b = false;
	boolean notFound = false;
	
	//test if bed alredy exists
	for(int i = 0; i < hasBedSet.size();i++){
	    bed = (Bed) hasBedSet.elementAt(i);
	    if(s[1].equals(bed.number)){
		b = false;
		return b;
	    }//if
	    notFound = true;
	}//for
	
	if(notFound == true && hasBedSet.size() > 0){
	Bed temp = new Bed(s[1], s[3],s[4], this);
	addHasBed(temp);
	b = true;
	return b;
	}//if
	
	if(hasBedSet.size() == 0){
	    Bed temp = new Bed(s[1], s[3],s[4], this);
	    addHasBed(temp);
	    b = true;
	    return b;
	}//if
	return b;
    }//createBed
    
    //returns a list og the bed for one room
    public String[] getBedList(){
	Bed bed;
	String[] list = new String[hasBedSet.size()];
	for(int i = 0; i < hasBedSet.size();i++){
	    bed = (Bed)hasBedSet.elementAt(i);
	    list[i] = bed.number;
	}//for
	return list;
    }//getBedList

    //delete a bed
    public void removeBed(String b){
	Bed bed;
	for(int i = 0; i < hasBedSet.size();i++){
	    bed = (Bed)hasBedSet.elementAt(i);
	    if(b.equals(bed.number)){
		removeHasBed(bed);
	    }//if
	}//for
    }//removeBed

    //change info on bed
    public void changeBed(String bed_, String[] list){
	Bed bed;
	for(int i = 0; i < hasBedSet.size();i++){
	    bed = (Bed)hasBedSet.elementAt(i);
	    if(bed_.equals(bed.number)){
		bed.number    = list[0];
		bed.type      = list[2];
		bed.available = list[3];
	    }//if
	}//for
    }//changeBed
    
    // Do not delete this line -- regeneration end marker

    // Attribute accessors

    public String getType(){
	return type;
    }
    
    public String getNumber() {
        return number;
    }

    public void setNumber(String number_) {
        number = number_;
    }

    public int getNumberOfBeds() {
        return numberOfBeds;
    }

    public void setNumberOfBeds(int numberOfBeds_) {
        numberOfBeds = numberOfBeds_;
    }

    // Association accessors

    public Ward getHasWard() {
        return hasWard;
    }

    public void setHasWard(Ward hasWard_) {
        if (hasWard != null)
         hasWard.hasRoomrSet.removeElement(this);
        if (hasWard_ != null)
         hasWard_.hasRoomrSet.addElement(this);
        hasWard = hasWard_;
    }

    public void addHasBed(Bed hasBed_) {
        if (hasBed_ == null)
            return;
        hasBed_.setRoom(null);
        hasBed_.room = this;
        hasBedSet.addElement(hasBed_);
    }

    public void removeHasBed(Bed hasBed_) {
        if (hasBed_ == null)
            return;
        hasBed_.room = null;
        hasBedSet.removeElement(hasBed_);
    }

//      public Vector getHasBedSet() {
//          return (Vector)hasBedSet.clone();
//      }

//      public void addHasOperation(Operation hasOperation_) {
//          if (hasOperation_ == null)
//              return;
//          hasOperation_.hasRoomSet.addElement(this);
//          hasOperationSet.addElement(hasOperation_);
//      }

//      public void removeHasOperation(Operation hasOperation_) {
//          if (hasOperation_ == null)
//              return;
//          hasOperation_.hasRoomSet.removeElement(this);
//          hasOperationSet.removeElement(hasOperation_);
//      }

//      public Vector getHasOperationSet() {
//          return (Vector)hasOperationSet.clone();
//      }

} // class Room


// Do not delete this line -- End Class Declarations











