// @(#)Ward.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


//
// File          : Ward.java
//
// Project       : IN219
// Configuration : Leveranse4 1
// Phase         : Implementation 1
// System        : Klasse 1
//
package model;

import java.util.Vector;
import java.io.*;
// Begin user import section


// End user import section

// Do not delete this line -- Start Class Declarations

public class Ward implements Serializable {

    // Data attributes
    public String number;
    public String name;
    public String type;
   

    // Association attributes

//      protected Waitlist hasWaitList;
      public Vector hasRoomrSet;
//      protected Vector hasEmployeeSet;
//      private Vector hasTurnusPlanSet;

    // Default constructor

//      public Ward(Waitlist hasWaitList_) {
//          hasWaitList = hasWaitList_;
    //    hasRoomrSet = new Vector();
//          hasEmployeeSet = new Vector();
//          hasTurnusPlanSet = new Vector();

//          // Start user code section
//          // End user code section
//      }


    // User defined constructors
    public Ward(String number_, String name_, String type_){
	hasRoomrSet = new Vector();
	number = number_;
	name = name_;
	type = type_;
    }

    // Methods

    public boolean createRoom(String[] s){
	boolean temp = false;
	boolean notFound = false;
	Room room;
	Room test;
	OperationRoom operationRoom;
	RecoveryRoom recoveryRoom;

	for(int i = 0; i < hasRoomrSet.size();i++){
	    test = (Room)hasRoomrSet.elementAt(i);
	    if(s[1].equals(test.number)){
		temp=false;
		return temp;
	    }//if
	    notFound = true;
	}//for
	
	
	if(s[3].equals("Operation")){
	    if(notFound == true && hasRoomrSet.size() > 0){
		OperationRoom r = new OperationRoom(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
		return temp;
	    }//if
	    if(hasRoomrSet.size() == 0){
		OperationRoom r = new OperationRoom(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
	    }//if
	}//if operation
	
	if(s[3].equals("Recovery")){
	    if(notFound == true && hasRoomrSet.size() > 0){
		RecoveryRoom r = new RecoveryRoom(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
		return temp;
	    }//if
	    if(hasRoomrSet.size() == 0){
		RecoveryRoom r = new RecoveryRoom(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
	    }//if
	}//if Recovery

	if(s[3].equals("Waiting")){
	    if(notFound == true && hasRoomrSet.size() > 0){
		Room r = new Room(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
		return temp;
	    }//if
	    
	    if(hasRoomrSet.size() == 0){
		Room r = new Room(s[1], s[3],s[4], this);
		addHasRoomr(r);
		temp = true;
	    }//if
	}//if Rest
	return temp;
    }//createRoom
    
    //get type of room
    public String getType(String room_){
	String s = "";
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room)hasRoomrSet.elementAt(i);
	    if(room.number.equals(room_))
		s = room.getType();
	}// for      
	return s;
    }//getType
    
    //locate a room and delete it
    public void removeRoom(String s){
	Room room;
	
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(s.equals(room.number)){
		removeHasRoomr(room);
	    }//if
	}//for
    }//removeRoom
    
    //gets data about room_ and returns them a String[] list
    public String[] displayRoom(String room_){
	String[] list = new String[4];
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(room_.equals(room.number)){
		list[0] = room.number;
		list[2] = room.type;
		list[3] = room.available;
	    }//if
	}//for
	return list;
    }//displayRoom

    //change data on room_
    public void changeRoom(String room_, String[] list){
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(room_.equals(room.number)){
		room.number = list[0];
		room.type = list[2];
		room.available = list[3];
	    }//if
	}//for
    }//changeRoom
    
    //change bed
    public void changeBed(String room_, String bed_, String[] list){
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(room_.equals(room.number))
		room.changeBed(bed_, list);
	}//for
    }//changeBed
    
    //delete a bed
    public void removeBed(String r, String b){
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(r.equals(room.number))
		room.removeBed(b);
	}//for
    }//removeBed

    //locate the corect room and tels it to construct a bed.
    public boolean createBed(String[] s){
	boolean b = false;
	Room room;
	
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room) hasRoomrSet.elementAt(i);
	    if(s[6].equals(room.number)){
		b = room.createBed(s);
		if(b == true){
		    return b;
		}//if
		
	    }//if
	}//for
	return b;
    }//createBed
   
    //returns a String[] og beds number
    public String[] getBedList(String s){
	Room room;
	String[] list = new String[0];
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room)hasRoomrSet.elementAt(i);
	    if(s.equals(room.number)){
		list = room.getBedList();
	    }//if
	}//for
	return list;
    }//getBedList

    //collects data on bed_ and returns String[] list
    public String[] displayBed(String room_, String bed_){
	Room room;
	String[] list = new String[4];
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room)hasRoomrSet.elementAt(i);
	    if(room_.equals(room.number)){
		list = room.displayBed(bed_);
	    }//if
	}//for
	return list;
    }//displayBed
    
    public String[] getRoomList(){
	String[] list = new String[hasRoomrSet.size()];
	Room room;
	for(int i = 0; i < hasRoomrSet.size();i++){
	    room = (Room)hasRoomrSet.elementAt(i);
	    list[i] = room.number;
	}//for
	return list;
    }//getRoomList
    
    public void giveRom() {
    }

    public void getInfoReport() {
    }

    public void addResources(String info) {
    }

    public void modifyResources(String info) {
    }

    public void removeWard(Ward w){}
    
    // Do not delete this line -- regeneration end marker

    // Attribute accessors



//      // Association accessors

//      public Waitlist getHasWaitList() {
//          return hasWaitList;
//      }

//      public void setHasWaitList(Waitlist hasWaitList_) {
//          if (hasWaitList != null)
//           hasWaitList.hasWard = null;
//          if (hasWaitList_ != null) {
//           hasWaitList_.setHasWard(null);
//           hasWaitList_.hasWard = this;
//          }
//          hasWaitList = hasWaitList_;
//      }

    public void addHasRoomr(Room hasRoomr_) {
        if (hasRoomr_ == null)
            return;
        hasRoomr_.setHasWard(null);
        hasRoomr_.hasWard = this;
        hasRoomrSet.addElement(hasRoomr_);
    }

    public void removeHasRoomr(Room hasRoomr_) {
        if (hasRoomr_ == null)
            return;
        hasRoomr_.hasWard = null;
        hasRoomrSet.removeElement(hasRoomr_);
    }

      public Vector getHasRoomrSet() {
          return (Vector)hasRoomrSet.clone();
      }

//      public void addHasEmployee(Employee hasEmployee_) {
//          if (hasEmployee_ == null)
//              return;
//          hasEmployee_.setHasWard(null);
//          hasEmployee_.hasWard = this;
//          hasEmployeeSet.addElement(hasEmployee_);
//      }

//      public void removeHasEmployee(Employee hasEmployee_) {
//          if (hasEmployee_ == null)
//              return;
//          hasEmployee_.hasWard = null;
//          hasEmployeeSet.removeElement(hasEmployee_);
//      }

//      public Vector getHasEmployeeSet() {
//          return (Vector)hasEmployeeSet.clone();
//      }

//      public void addHasTurnusPlan(Turnusplan hasTurnusPlan_) {
//          if (hasTurnusPlan_ == null)
//              return;
//          hasTurnusPlanSet.addElement(hasTurnusPlan_);
//      }

//      public void removeHasTurnusPlan(Turnusplan hasTurnusPlan_) {
//          if (hasTurnusPlan_ == null)
//              return;
//          hasTurnusPlanSet.removeElement(hasTurnusPlan_);
//      }

//      public Vector getHasTurnusPlanSet() {
//          return (Vector)hasTurnusPlanSet.clone();
//      }

} // class Ward


// Do not delete this line -- End Class Declarations
