// @(#)WardRegister.java        1.1 03/09/20
//  Copyright (c)  Simula Research Laboratory AS.
//  Martin Linges v. 17, 1367 Snarya Brum, Norway
//  All rights reserved.
//  This software is for use at University of Oslo for 
//  teaching purposes only. 
    
//        @version     1.1 20 Sep 2003
//        @author      Eskild Busch


//
// File          : WardRegister.java
//
// Project       : IN219
// Configuration : Leveranse4 1
// Phase         : Implementation 1
// System        : Klasse 1
//

package model;


import java.util.Vector;
import java.io.*;
// Begin user import section


// End user import section

// Do not delete this line -- Start Class Declarations

public class WardRegister implements Serializable{

    // Data attributes

    public int numberOfWards = 1;
    
    // Association attributes

    public Vector hasWardSet;

    // Default constructor

    public WardRegister() {
	hasWardSet = new Vector();

        // Start user code section
        // End user code section
    }


    // User defined constructors


    // Methods
    
    //change info on bed
    public void changeBed(String ward_, String room_, String bed_,
	String[] list){
	Ward ward = getWard(ward_);
	if(ward != null){
	    ward.changeBed(room_, bed_, list);
	}//if
    }//changeBed
    
    //add a bed to a spesific room in a spesific ward
    public boolean createBed(String[] s){
	boolean b = false;
	Ward ward, temp;
	for(int i = 0; i < hasWardSet.size();i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    if(s[5].equals(ward.name)){
		b = ward.createBed(s);
		if(b == true)
		    return b;
	    }//if
	}//for
	return b;
    }//addBed

    //returns a list of Beds
    public String[] getBedList(String w, String r){
	String[] list = new String[0];
	Ward ward;
	for(int i = 0; i < hasWardSet.size();i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    if(w.equals(ward.name)){
		list = ward.getBedList(r);
	    }//if
	}//for
	return list;
    }//getBedList

    //delete a bed
    public void removeBed(String ward_, String r, String b){
	Ward ward = getWard(ward_);
	if(ward != null){
	ward.removeBed(r,b);
	}
    }//removeBed
    
    //gets data about bed_ andd rturn them as String[]
    public String[] displayBed(String ward_, String room_, String bed_){
	Ward ward = getWard(ward_);
	String[] list = new String[4];
	if(ward != null){
	    list = ward.displayBed(room_, bed_);
	}
	return list;
    }//displayBed

    //change a room
    public void changeRoom(String ward_, String room_, String[] list){
	Ward ward = getWard(ward_);
	if(ward != null){
	    ward.changeRoom(room_, list);
	}
    }//changeRoom
    
    //delete a room
    public void removeRoom(String ward_, String s){
	Ward ward = getWard(ward_);
	if(ward != null){
	ward.removeRoom(s);
	}
    }//removeRoom
    

    //add a room to a spesific ward
    public boolean createRoom(String[] s){
	Ward ward;
	boolean b = false;

	for(int i = 0; i < hasWardSet.size();i++){
	    ward= (Ward)hasWardSet.elementAt(i);
	    if(s[5].equals(ward.name)){
		b = ward.createRoom(s);
		if(b == true)
		    return b;
	    }//if
	}//for
	return b;
    }//addRoom

    //returns a list of room assosiated with ward s
    public String[] getRoomList(String s){
	Ward ward;
	String[] list = new String[0]; 
	for(int i = 0; i < hasWardSet.size(); i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    if(s.equals(ward.name)){
		list = ward.getRoomList();
		return list;
	    }//if
	}//for
	
	return list;
    }//getRoomList

    //collects data about room_ and return String[] list
    public String[] displayRoom(String ward_, String room_){
	Ward ward = getWard(ward_);
	String[] list = new String[3];
	if(ward != null){
	    list = ward.displayRoom(room_);
	}//if
	return list;
    }//displayRoom


    //change information on the given ward
    public void changeWard(String ward_, String[] list){
	Ward ward = getWard(ward_);
	if(ward != null){
	    ward.number = list[0];
	    ward.name = list[1];
	    ward.type = list[2];
	}//if
    }//changeWard

    //remove Ward w from the vector.
    public void removeWard(String ward_){
	Ward ward = getWard(ward_);
	if(ward != null){
	removeHasWard(ward);
	}
    }//removeWard
   
    //called from control class and creates a new ward object and 
    //put it in the hasWardSet vector
    public boolean createWard(String[] s){
	boolean b = false;
	Ward temp;
	for(int i = 0; i < hasWardSet.size();i++){
	    temp = (Ward)hasWardSet.elementAt(i);
	    if(s[1].equals(temp.number)){
		return b;
	    }//if
	}//for
   
	if(hasWardSet.size() > 0){
	    Ward w = new Ward(s[1], s[2], s[3]);
	    addHasWard(w);
	    b = true;
	}
	
	if(hasWardSet.size() == 0){
	    Ward w = new Ward(s[1], s[2], s[3]);
	    addHasWard(w);
	    b = true;
	}//if
	return b;
    }//createWard
    
    //get type of room
    public String getType(String ward_, String room_){
	String s = "";
	Ward ward;
	for(int i = 0; i < hasWardSet.size();i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    if(ward.name.equals(ward_))
		s = ward.getType(room_);
	}// for      
	return s;
    }//getType
    
    public Ward getWard(String s) {
	Ward ward = null;
	for(int i = 0; i < hasWardSet.size();i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    if(ward.name.equals(s))
		return ward;
	}// for      
	return ward;
    }//getWard
    
    //find the correct resource and return its info
    public String[] getWardInfo(String s){
	String[] list = new String[4];
	Ward w = getWard(s);
	if(w == null)
	    return list;

	list[0] = w.number;
	list[1] = w.name;
	list[2] = w.type;
	
	return list;
    }//getResourceInfo
    
    //returns a String[] whit the name of the wards.
    public String[] getWardList(){
	String[] list = new String[hasWardSet.size()];
	Ward ward;
	for(int i = 0; i < hasWardSet.size();i++){
	    ward = (Ward)hasWardSet.elementAt(i);
	    list[i] = ward.name;
	}
	return list;
    }//getList
    
    //gets data about ward_ and return them as a String[]
    public String[] displayWard(String ward_){
	Ward ward = getWard(ward_);
	String[] list = new String[4];
	if(ward != null){
	    list[0] = ward.number;
	    list[1] = ward.name;
	    list[2] = ward.type;
	    list[3] = " ";
	}
	return list;
    }//displayWard
    

    // Do not delete this line -- regeneration end marker
    // Attribute accessors
    
    public int getNumberOfWards() {
        return numberOfWards;
    }

    public void setNumberOfWards(int numberOfWards_) {
        numberOfWards = numberOfWards_;
    }


    // Association accessors

    public void addHasWard(Ward hasWard_) {
        if (hasWard_ == null)
            return;
        hasWardSet.addElement(hasWard_);
    }

    public void removeHasWard(Ward hasWard_) {
        if (hasWard_ == null)
            return;
        hasWardSet.removeElement(hasWard_);
    }

    public Vector getHasWardSet() {
        return (Vector)hasWardSet.clone();
    }

} // class WardRegister


// Do not delete this line -- End Class Declarations








 




